/* buildtask.c generated by valac 0.56.17, the Vala compiler
 * generated from buildtask.vala, do not modify */

/* buildtask.vala
 *
 * Copyright 2020 Princeton Ferro <princetonferro@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define VLS_TYPE_BUILD_TARGET (vls_build_target_get_type ())
#define VLS_BUILD_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_BUILD_TARGET, VlsBuildTarget))
#define VLS_BUILD_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_BUILD_TARGET, VlsBuildTargetClass))
#define VLS_IS_BUILD_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_BUILD_TARGET))
#define VLS_IS_BUILD_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_BUILD_TARGET))
#define VLS_BUILD_TARGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_BUILD_TARGET, VlsBuildTargetClass))

typedef struct _VlsBuildTarget VlsBuildTarget;
typedef struct _VlsBuildTargetClass VlsBuildTargetClass;
typedef struct _VlsBuildTargetPrivate VlsBuildTargetPrivate;

#define VLS_TYPE_BUILD_TASK (vls_build_task_get_type ())
#define VLS_BUILD_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_BUILD_TASK, VlsBuildTask))
#define VLS_BUILD_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_BUILD_TASK, VlsBuildTaskClass))
#define VLS_IS_BUILD_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_BUILD_TASK))
#define VLS_IS_BUILD_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_BUILD_TASK))
#define VLS_BUILD_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_BUILD_TASK, VlsBuildTaskClass))

typedef struct _VlsBuildTask VlsBuildTask;
typedef struct _VlsBuildTaskClass VlsBuildTaskClass;
typedef struct _VlsBuildTaskPrivate VlsBuildTaskPrivate;

#define VLS_TYPE_FILE_CACHE (vls_file_cache_get_type ())
#define VLS_FILE_CACHE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_FILE_CACHE, VlsFileCache))
#define VLS_FILE_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_FILE_CACHE, VlsFileCacheClass))
#define VLS_IS_FILE_CACHE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_FILE_CACHE))
#define VLS_IS_FILE_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_FILE_CACHE))
#define VLS_FILE_CACHE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_FILE_CACHE, VlsFileCacheClass))

typedef struct _VlsFileCache VlsFileCache;
typedef struct _VlsFileCacheClass VlsFileCacheClass;
enum  {
	VLS_BUILD_TASK_0_PROPERTY,
	VLS_BUILD_TASK_USED_FILES_PROPERTY,
	VLS_BUILD_TASK_CANDIDATE_INPUTS_PROPERTY,
	VLS_BUILD_TASK_NUM_PROPERTIES
};
static GParamSpec* vls_build_task_properties[VLS_BUILD_TASK_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define VLS_TYPE_PROJECT_ERROR (vls_project_error_get_type ())
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))

struct _VlsBuildTarget {
	GObject parent_instance;
	VlsBuildTargetPrivate * priv;
};

struct _VlsBuildTargetClass {
	GObjectClass parent_class;
	void (*build_if_stale) (VlsBuildTarget* self, GCancellable* cancellable, GError** error);
};

struct _VlsBuildTask {
	VlsBuildTarget parent_instance;
	VlsBuildTaskPrivate * priv;
};

struct _VlsBuildTaskClass {
	VlsBuildTargetClass parent_class;
};

struct _VlsBuildTaskPrivate {
	gchar** arguments;
	gint arguments_length1;
	gint _arguments_size_;
	gchar* exe_name;
	gchar* build_dir;
	GSubprocessLauncher* launcher;
	GeeArrayList* _used_files;
	GeeArrayList* _candidate_inputs;
	VlsFileCache* _file_cache;
};

typedef enum  {
	VLS_PROJECT_ERROR_VERSION_UNSUPPORTED,
	VLS_PROJECT_ERROR_INTROSPECTION,
	VLS_PROJECT_ERROR_CONFIGURATION,
	VLS_PROJECT_ERROR_TASK_FAILED,
	VLS_PROJECT_ERROR_NOT_FOUND
} VlsProjectError;
#define VLS_PROJECT_ERROR vls_project_error_quark ()

static gint VlsBuildTask_private_offset;
static gpointer vls_build_task_parent_class = NULL;

VALA_EXTERN GType vls_build_target_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsBuildTarget, g_object_unref)
VALA_EXTERN GType vls_build_task_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsBuildTask, g_object_unref)
VALA_EXTERN GType vls_file_cache_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsFileCache, g_object_unref)
VALA_EXTERN void vls_build_target_build_if_stale (VlsBuildTarget* self,
                                      GCancellable* cancellable,
                                      GError** error);
VALA_EXTERN VlsBuildTask* vls_build_task_new (VlsFileCache* file_cache,
                                  const gchar* build_dir,
                                  const gchar* output_dir,
                                  const gchar* name,
                                  const gchar* id,
                                  gint no,
                                  gchar** compiler,
                                  gint compiler_length1,
                                  gchar** args,
                                  gint args_length1,
                                  gchar** sources,
                                  gint sources_length1,
                                  gchar** generated_sources,
                                  gint generated_sources_length1,
                                  gchar** target_output_files,
                                  gint target_output_files_length1,
                                  const gchar* language,
                                  GError** error);
VALA_EXTERN VlsBuildTask* vls_build_task_construct (GType object_type,
                                        VlsFileCache* file_cache,
                                        const gchar* build_dir,
                                        const gchar* output_dir,
                                        const gchar* name,
                                        const gchar* id,
                                        gint no,
                                        gchar** compiler,
                                        gint compiler_length1,
                                        gchar** args,
                                        gint args_length1,
                                        gchar** sources,
                                        gint sources_length1,
                                        gchar** generated_sources,
                                        gint generated_sources_length1,
                                        gchar** target_output_files,
                                        gint target_output_files_length1,
                                        const gchar* language,
                                        GError** error);
VALA_EXTERN VlsBuildTarget* vls_build_target_construct (GType object_type,
                                            const gchar* output_dir,
                                            const gchar* name,
                                            const gchar* id,
                                            gint no);
static void _vala_array_add15 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add16 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN gboolean vls_util_arg_is_vala_file (const gchar* arg);
VALA_EXTERN GeeArrayList* vls_build_task_get_used_files (VlsBuildTask* self);
static void _vala_array_add17 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add18 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN GeeArrayList* vls_build_target_get_input (VlsBuildTarget* self);
static void _vala_array_add19 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN gint vls_util_iterate_valac_args (gchar** args,
                                  gint args_length1,
                                  gchar** flag_name,
                                  gchar** arg_value,
                                  gint last_arg_index);
VALA_EXTERN GeeArrayList* vls_build_target_get_output (VlsBuildTarget* self);
VALA_EXTERN GQuark vls_project_error_quark (void);
VALA_EXTERN GType vls_project_error_get_type (void) G_GNUC_CONST ;
static gchar* _______lambda12_ (VlsBuildTask* self,
                         GFile* f);
static gpointer ________lambda12__gee_map_func (gpointer g,
                                         gpointer self);
static gchar* _______lambda13_ (VlsBuildTask* self,
                         gchar* rightacc,
                         gchar* elem);
static gpointer ________lambda13__gee_fold_func (gpointer g,
                                          gpointer a,
                                          gpointer self);
static void _vala_array_add20 (GFile** * array,
                        gint* length,
                        gint* size,
                        GFile* value);
VALA_EXTERN GFile** vls_util_discover_gresources_xml_input_files (const gchar* gresources_xml,
                                                      GFile** source_dirs,
                                                      gint source_dirs_length1,
                                                      gint* result_length1,
                                                      GError** error);
VALA_EXTERN GeeArrayList* vls_build_task_get_candidate_inputs (VlsBuildTask* self);
static void vls_build_task_real_build_if_stale (VlsBuildTarget* base,
                                         GCancellable* cancellable,
                                         GError** error);
VALA_EXTERN const gchar* vls_build_target_get_id (VlsBuildTarget* self);
VALA_EXTERN GDateTime* vls_build_target_get_last_updated (VlsBuildTarget* self);
VALA_EXTERN void vls_file_cache_update (VlsFileCache* self,
                            GFile* file,
                            GCancellable* cancellable,
                            GError** error);
VALA_EXTERN void vls_build_target_set_last_updated (VlsBuildTarget* self,
                                        GDateTime* value);
static void vls_build_task_set_used_files (VlsBuildTask* self,
                                    GeeArrayList* value);
static void vls_build_task_set_candidate_inputs (VlsBuildTask* self,
                                          GeeArrayList* value);
static void vls_build_task_finalize (GObject * obj);
static GType vls_build_task_get_type_once (void);
static void _vala_vls_build_task_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_vls_build_task_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
vls_build_task_get_instance_private (VlsBuildTask* self)
{
	return G_STRUCT_MEMBER_P (self, VlsBuildTask_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 50 "../src/projects/buildtask.vala"
	return self ? g_object_ref (self) : NULL;
#line 282 "buildtask.c"
}

static void
_vala_array_add15 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 60 "../src/projects/buildtask.vala"
	if ((*length) == (*size)) {
#line 60 "../src/projects/buildtask.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 60 "../src/projects/buildtask.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 297 "buildtask.c"
	}
#line 60 "../src/projects/buildtask.vala"
	(*array)[(*length)++] = value;
#line 60 "../src/projects/buildtask.vala"
	(*array)[*length] = NULL;
#line 303 "buildtask.c"
}

static void
_vala_array_add16 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 67 "../src/projects/buildtask.vala"
	if ((*length) == (*size)) {
#line 67 "../src/projects/buildtask.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 67 "../src/projects/buildtask.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 318 "buildtask.c"
	}
#line 67 "../src/projects/buildtask.vala"
	(*array)[(*length)++] = value;
#line 67 "../src/projects/buildtask.vala"
	(*array)[*length] = NULL;
#line 324 "buildtask.c"
}

static void
_vala_array_add17 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 80 "../src/projects/buildtask.vala"
	if ((*length) == (*size)) {
#line 80 "../src/projects/buildtask.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 80 "../src/projects/buildtask.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 339 "buildtask.c"
	}
#line 80 "../src/projects/buildtask.vala"
	(*array)[(*length)++] = value;
#line 80 "../src/projects/buildtask.vala"
	(*array)[*length] = NULL;
#line 345 "buildtask.c"
}

static void
_vala_array_add18 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 91 "../src/projects/buildtask.vala"
	if ((*length) == (*size)) {
#line 91 "../src/projects/buildtask.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 91 "../src/projects/buildtask.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 360 "buildtask.c"
	}
#line 91 "../src/projects/buildtask.vala"
	(*array)[(*length)++] = value;
#line 91 "../src/projects/buildtask.vala"
	(*array)[*length] = NULL;
#line 366 "buildtask.c"
}

static void
_vala_array_add19 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 97 "../src/projects/buildtask.vala"
	if ((*length) == (*size)) {
#line 97 "../src/projects/buildtask.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 97 "../src/projects/buildtask.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 381 "buildtask.c"
	}
#line 97 "../src/projects/buildtask.vala"
	(*array)[(*length)++] = value;
#line 97 "../src/projects/buildtask.vala"
	(*array)[*length] = NULL;
#line 387 "buildtask.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 400 "buildtask.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 423 "buildtask.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 432 "buildtask.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 451 "buildtask.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 455 "buildtask.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 461 "buildtask.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 471 "buildtask.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 479 "buildtask.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 483 "buildtask.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 489 "buildtask.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 499 "buildtask.c"
}

static gchar*
_______lambda12_ (VlsBuildTask* self,
                  GFile* f)
{
	gchar* _tmp0_;
	gchar* result;
#line 188 "../src/projects/buildtask.vala"
	g_return_val_if_fail (f != NULL, NULL);
#line 188 "../src/projects/buildtask.vala"
	_tmp0_ = g_file_get_path (f);
#line 188 "../src/projects/buildtask.vala"
	result = _tmp0_;
#line 188 "../src/projects/buildtask.vala"
	_g_object_unref0 (f);
#line 188 "../src/projects/buildtask.vala"
	return result;
#line 518 "buildtask.c"
}

static gpointer
________lambda12__gee_map_func (gpointer g,
                                gpointer self)
{
	gpointer result;
	result = _______lambda12_ ((VlsBuildTask*) self, (GFile*) g);
#line 187 "../src/projects/buildtask.vala"
	return result;
#line 529 "buildtask.c"
}

static gchar*
_______lambda13_ (VlsBuildTask* self,
                  gchar* rightacc,
                  gchar* elem)
{
	gchar* _tmp0_ = NULL;
	gchar* result;
#line 189 "../src/projects/buildtask.vala"
	g_return_val_if_fail (rightacc != NULL, NULL);
#line 189 "../src/projects/buildtask.vala"
	g_return_val_if_fail (elem != NULL, NULL);
#line 189 "../src/projects/buildtask.vala"
	if (g_strcmp0 (elem, "") != 0) {
#line 545 "buildtask.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 189 "../src/projects/buildtask.vala"
		_tmp1_ = string_to_string (elem);
#line 189 "../src/projects/buildtask.vala"
		_tmp2_ = string_to_string (rightacc);
#line 189 "../src/projects/buildtask.vala"
		_tmp3_ = g_strconcat (_tmp1_, ", ", _tmp2_, NULL);
#line 189 "../src/projects/buildtask.vala"
		_g_free0 (_tmp0_);
#line 189 "../src/projects/buildtask.vala"
		_tmp0_ = _tmp3_;
#line 559 "buildtask.c"
	} else {
		gchar* _tmp4_;
#line 189 "../src/projects/buildtask.vala"
		_tmp4_ = g_strdup (rightacc);
#line 189 "../src/projects/buildtask.vala"
		_g_free0 (_tmp0_);
#line 189 "../src/projects/buildtask.vala"
		_tmp0_ = _tmp4_;
#line 568 "buildtask.c"
	}
#line 189 "../src/projects/buildtask.vala"
	result = _tmp0_;
#line 189 "../src/projects/buildtask.vala"
	_g_free0 (rightacc);
#line 189 "../src/projects/buildtask.vala"
	_g_free0 (elem);
#line 189 "../src/projects/buildtask.vala"
	return result;
#line 578 "buildtask.c"
}

static gpointer
________lambda13__gee_fold_func (gpointer g,
                                 gpointer a,
                                 gpointer self)
{
	gpointer result;
	result = _______lambda13_ ((VlsBuildTask*) self, (gchar*) g, (gchar*) a);
#line 187 "../src/projects/buildtask.vala"
	return result;
#line 590 "buildtask.c"
}

static void
_vala_array_add20 (GFile** * array,
                   gint* length,
                   gint* size,
                   GFile* value)
{
#line 232 "../src/projects/buildtask.vala"
	if ((*length) == (*size)) {
#line 232 "../src/projects/buildtask.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 232 "../src/projects/buildtask.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 605 "buildtask.c"
	}
#line 232 "../src/projects/buildtask.vala"
	(*array)[(*length)++] = value;
#line 232 "../src/projects/buildtask.vala"
	(*array)[*length] = NULL;
#line 611 "buildtask.c"
}

VlsBuildTask*
vls_build_task_construct (GType object_type,
                          VlsFileCache* file_cache,
                          const gchar* build_dir,
                          const gchar* output_dir,
                          const gchar* name,
                          const gchar* id,
                          gint no,
                          gchar** compiler,
                          gint compiler_length1,
                          gchar** args,
                          gint args_length1,
                          gchar** sources,
                          gint sources_length1,
                          gchar** generated_sources,
                          gint generated_sources_length1,
                          gchar** target_output_files,
                          gint target_output_files_length1,
                          const gchar* language,
                          GError** error)
{
	VlsBuildTask * self = NULL;
	VlsFileCache* _tmp0_;
	gchar* _tmp1_;
	GSubprocessLauncher* _tmp2_;
	GSubprocessLauncher* _tmp3_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	gchar* _tmp52_ = NULL;
	gchar* cmd_basename = NULL;
	gchar* _tmp55_;
	const gchar* _tmp56_;
	gboolean _tmp89_ = FALSE;
	gboolean _tmp90_ = FALSE;
	const gchar* _tmp91_;
	GError* _inner_error0_ = NULL;
#line 45 "../src/projects/buildtask.vala"
	g_return_val_if_fail (file_cache != NULL, NULL);
#line 45 "../src/projects/buildtask.vala"
	g_return_val_if_fail (build_dir != NULL, NULL);
#line 45 "../src/projects/buildtask.vala"
	g_return_val_if_fail (output_dir != NULL, NULL);
#line 45 "../src/projects/buildtask.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 45 "../src/projects/buildtask.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 45 "../src/projects/buildtask.vala"
	g_return_val_if_fail (language != NULL, NULL);
#line 49 "../src/projects/buildtask.vala"
	self = (VlsBuildTask*) vls_build_target_construct (object_type, output_dir, name, id, no);
#line 50 "../src/projects/buildtask.vala"
	_tmp0_ = _g_object_ref0 (file_cache);
#line 50 "../src/projects/buildtask.vala"
	_g_object_unref0 (self->priv->_file_cache);
#line 50 "../src/projects/buildtask.vala"
	self->priv->_file_cache = _tmp0_;
#line 52 "../src/projects/buildtask.vala"
	_tmp1_ = g_strdup (build_dir);
#line 52 "../src/projects/buildtask.vala"
	_g_free0 (self->priv->build_dir);
#line 52 "../src/projects/buildtask.vala"
	self->priv->build_dir = _tmp1_;
#line 53 "../src/projects/buildtask.vala"
	_tmp2_ = g_subprocess_launcher_new (G_SUBPROCESS_FLAGS_STDOUT_PIPE);
#line 53 "../src/projects/buildtask.vala"
	if (_tmp2_) {
#line 53 "../src/projects/buildtask.vala"
		g_object_set_data ((GObject *) _tmp2_, "vala-creation-function", "Vls.BuildTask.new");
#line 682 "buildtask.c"
	}
#line 53 "../src/projects/buildtask.vala"
	_g_object_unref0 (self->priv->launcher);
#line 53 "../src/projects/buildtask.vala"
	self->priv->launcher = _tmp2_;
#line 54 "../src/projects/buildtask.vala"
	_tmp3_ = self->priv->launcher;
#line 54 "../src/projects/buildtask.vala"
	g_subprocess_launcher_set_cwd (_tmp3_, build_dir);
#line 692 "buildtask.c"
	{
		gchar** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
#line 56 "../src/projects/buildtask.vala"
		arg_collection = compiler;
#line 56 "../src/projects/buildtask.vala"
		arg_collection_length1 = compiler_length1;
#line 56 "../src/projects/buildtask.vala"
		for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
#line 704 "buildtask.c"
			gchar* _tmp4_;
			gchar* arg = NULL;
#line 56 "../src/projects/buildtask.vala"
			_tmp4_ = g_strdup (arg_collection[arg_it]);
#line 56 "../src/projects/buildtask.vala"
			arg = _tmp4_;
#line 711 "buildtask.c"
			{
				gchar** _tmp5_;
				gint _tmp5__length1;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				gchar* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
#line 57 "../src/projects/buildtask.vala"
				_tmp5_ = self->priv->arguments;
#line 57 "../src/projects/buildtask.vala"
				_tmp5__length1 = self->priv->arguments_length1;
#line 57 "../src/projects/buildtask.vala"
				if (_tmp5__length1 > 0) {
#line 726 "buildtask.c"
					const gchar* _tmp6_;
					gchar* _tmp7_;
#line 58 "../src/projects/buildtask.vala"
					_tmp6_ = self->priv->exe_name;
#line 58 "../src/projects/buildtask.vala"
					_tmp7_ = g_strconcat (_tmp6_, " ", NULL);
#line 58 "../src/projects/buildtask.vala"
					_g_free0 (self->priv->exe_name);
#line 58 "../src/projects/buildtask.vala"
					self->priv->exe_name = _tmp7_;
#line 737 "buildtask.c"
				}
#line 59 "../src/projects/buildtask.vala"
				_tmp8_ = self->priv->exe_name;
#line 59 "../src/projects/buildtask.vala"
				_tmp9_ = arg;
#line 59 "../src/projects/buildtask.vala"
				_tmp10_ = g_strconcat (_tmp8_, _tmp9_, NULL);
#line 59 "../src/projects/buildtask.vala"
				_g_free0 (self->priv->exe_name);
#line 59 "../src/projects/buildtask.vala"
				self->priv->exe_name = _tmp10_;
#line 60 "../src/projects/buildtask.vala"
				_tmp11_ = arg;
#line 60 "../src/projects/buildtask.vala"
				_tmp12_ = g_strdup (_tmp11_);
#line 60 "../src/projects/buildtask.vala"
				_vala_array_add15 (&self->priv->arguments, &self->priv->arguments_length1, &self->priv->_arguments_size_, _tmp12_);
#line 56 "../src/projects/buildtask.vala"
				_g_free0 (arg);
#line 757 "buildtask.c"
			}
		}
	}
	{
		gchar** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
#line 63 "../src/projects/buildtask.vala"
		arg_collection = args;
#line 63 "../src/projects/buildtask.vala"
		arg_collection_length1 = args_length1;
#line 63 "../src/projects/buildtask.vala"
		for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
#line 772 "buildtask.c"
			gchar* _tmp13_;
			gchar* arg = NULL;
#line 63 "../src/projects/buildtask.vala"
			_tmp13_ = g_strdup (arg_collection[arg_it]);
#line 63 "../src/projects/buildtask.vala"
			arg = _tmp13_;
#line 779 "buildtask.c"
			{
				gchar** _tmp14_;
				gint _tmp14__length1;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				const gchar* _tmp20_;
				gchar* _tmp21_;
#line 64 "../src/projects/buildtask.vala"
				_tmp14_ = self->priv->arguments;
#line 64 "../src/projects/buildtask.vala"
				_tmp14__length1 = self->priv->arguments_length1;
#line 64 "../src/projects/buildtask.vala"
				if (_tmp14__length1 > 0) {
#line 794 "buildtask.c"
					const gchar* _tmp15_;
					gchar* _tmp16_;
#line 65 "../src/projects/buildtask.vala"
					_tmp15_ = self->priv->exe_name;
#line 65 "../src/projects/buildtask.vala"
					_tmp16_ = g_strconcat (_tmp15_, " ", NULL);
#line 65 "../src/projects/buildtask.vala"
					_g_free0 (self->priv->exe_name);
#line 65 "../src/projects/buildtask.vala"
					self->priv->exe_name = _tmp16_;
#line 805 "buildtask.c"
				}
#line 66 "../src/projects/buildtask.vala"
				_tmp17_ = self->priv->exe_name;
#line 66 "../src/projects/buildtask.vala"
				_tmp18_ = arg;
#line 66 "../src/projects/buildtask.vala"
				_tmp19_ = g_strconcat (_tmp17_, _tmp18_, NULL);
#line 66 "../src/projects/buildtask.vala"
				_g_free0 (self->priv->exe_name);
#line 66 "../src/projects/buildtask.vala"
				self->priv->exe_name = _tmp19_;
#line 67 "../src/projects/buildtask.vala"
				_tmp20_ = arg;
#line 67 "../src/projects/buildtask.vala"
				_tmp21_ = g_strdup (_tmp20_);
#line 67 "../src/projects/buildtask.vala"
				_vala_array_add16 (&self->priv->arguments, &self->priv->arguments_length1, &self->priv->_arguments_size_, _tmp21_);
#line 63 "../src/projects/buildtask.vala"
				_g_free0 (arg);
#line 825 "buildtask.c"
			}
		}
	}
#line 70 "../src/projects/buildtask.vala"
	_tmp22_ = self->priv->arguments;
#line 70 "../src/projects/buildtask.vala"
	_tmp22__length1 = self->priv->arguments_length1;
#line 833 "buildtask.c"
	{
		gchar** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
#line 70 "../src/projects/buildtask.vala"
		arg_collection = _tmp22_;
#line 70 "../src/projects/buildtask.vala"
		arg_collection_length1 = _tmp22__length1;
#line 70 "../src/projects/buildtask.vala"
		for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
#line 845 "buildtask.c"
			gchar* _tmp23_;
			gchar* arg = NULL;
#line 70 "../src/projects/buildtask.vala"
			_tmp23_ = g_strdup (arg_collection[arg_it]);
#line 70 "../src/projects/buildtask.vala"
			arg = _tmp23_;
#line 852 "buildtask.c"
			{
				const gchar* _tmp24_;
#line 71 "../src/projects/buildtask.vala"
				_tmp24_ = arg;
#line 71 "../src/projects/buildtask.vala"
				if (vls_util_arg_is_vala_file (_tmp24_)) {
#line 859 "buildtask.c"
					GFile* file = NULL;
					const gchar* _tmp25_;
					GFile* _tmp26_;
					GeeArrayList* _tmp27_;
					GFile* _tmp28_;
#line 72 "../src/projects/buildtask.vala"
					_tmp25_ = arg;
#line 72 "../src/projects/buildtask.vala"
					_tmp26_ = g_file_new_for_commandline_arg_and_cwd (_tmp25_, output_dir);
#line 72 "../src/projects/buildtask.vala"
					file = _tmp26_;
#line 73 "../src/projects/buildtask.vala"
					_tmp27_ = self->priv->_used_files;
#line 73 "../src/projects/buildtask.vala"
					_tmp28_ = file;
#line 73 "../src/projects/buildtask.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, _tmp28_);
#line 71 "../src/projects/buildtask.vala"
					_g_object_unref0 (file);
#line 879 "buildtask.c"
				}
#line 70 "../src/projects/buildtask.vala"
				_g_free0 (arg);
#line 883 "buildtask.c"
			}
		}
	}
#line 78 "../src/projects/buildtask.vala"
	if (g_strcmp0 (language, "c") == 0) {
#line 889 "buildtask.c"
		gchar* _tmp29_;
#line 80 "../src/projects/buildtask.vala"
		_tmp29_ = g_strdup ("-fdiagnostics-color=never");
#line 80 "../src/projects/buildtask.vala"
		_vala_array_add17 (&self->priv->arguments, &self->priv->arguments_length1, &self->priv->_arguments_size_, _tmp29_);
#line 895 "buildtask.c"
	}
	{
		gchar** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
#line 83 "../src/projects/buildtask.vala"
		arg_collection = sources;
#line 83 "../src/projects/buildtask.vala"
		arg_collection_length1 = sources_length1;
#line 83 "../src/projects/buildtask.vala"
		for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
#line 908 "buildtask.c"
			gchar* _tmp30_;
			gchar* arg = NULL;
#line 83 "../src/projects/buildtask.vala"
			_tmp30_ = g_strdup (arg_collection[arg_it]);
#line 83 "../src/projects/buildtask.vala"
			arg = _tmp30_;
#line 915 "buildtask.c"
			{
				GeeArrayList* _tmp39_;
				GeeArrayList* _tmp40_;
				const gchar* _tmp41_;
				GFile* _tmp42_;
				GFile* _tmp43_;
#line 87 "../src/projects/buildtask.vala"
				if (g_strcmp0 (language, "c") == 0) {
#line 924 "buildtask.c"
					gchar** _tmp31_;
					gint _tmp31__length1;
					const gchar* _tmp34_;
					const gchar* _tmp35_;
					gchar* _tmp36_;
					const gchar* _tmp37_;
					gchar* _tmp38_;
#line 88 "../src/projects/buildtask.vala"
					_tmp31_ = self->priv->arguments;
#line 88 "../src/projects/buildtask.vala"
					_tmp31__length1 = self->priv->arguments_length1;
#line 88 "../src/projects/buildtask.vala"
					if (_tmp31__length1 > 0) {
#line 938 "buildtask.c"
						const gchar* _tmp32_;
						gchar* _tmp33_;
#line 89 "../src/projects/buildtask.vala"
						_tmp32_ = self->priv->exe_name;
#line 89 "../src/projects/buildtask.vala"
						_tmp33_ = g_strconcat (_tmp32_, " ", NULL);
#line 89 "../src/projects/buildtask.vala"
						_g_free0 (self->priv->exe_name);
#line 89 "../src/projects/buildtask.vala"
						self->priv->exe_name = _tmp33_;
#line 949 "buildtask.c"
					}
#line 90 "../src/projects/buildtask.vala"
					_tmp34_ = self->priv->exe_name;
#line 90 "../src/projects/buildtask.vala"
					_tmp35_ = arg;
#line 90 "../src/projects/buildtask.vala"
					_tmp36_ = g_strconcat (_tmp34_, _tmp35_, NULL);
#line 90 "../src/projects/buildtask.vala"
					_g_free0 (self->priv->exe_name);
#line 90 "../src/projects/buildtask.vala"
					self->priv->exe_name = _tmp36_;
#line 91 "../src/projects/buildtask.vala"
					_tmp37_ = arg;
#line 91 "../src/projects/buildtask.vala"
					_tmp38_ = g_strdup (_tmp37_);
#line 91 "../src/projects/buildtask.vala"
					_vala_array_add18 (&self->priv->arguments, &self->priv->arguments_length1, &self->priv->_arguments_size_, _tmp38_);
#line 967 "buildtask.c"
				}
#line 93 "../src/projects/buildtask.vala"
				_tmp39_ = vls_build_target_get_input ((VlsBuildTarget*) self);
#line 93 "../src/projects/buildtask.vala"
				_tmp40_ = _tmp39_;
#line 93 "../src/projects/buildtask.vala"
				_tmp41_ = arg;
#line 93 "../src/projects/buildtask.vala"
				_tmp42_ = g_file_new_for_commandline_arg_and_cwd (_tmp41_, output_dir);
#line 93 "../src/projects/buildtask.vala"
				_tmp43_ = _tmp42_;
#line 93 "../src/projects/buildtask.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp40_, _tmp43_);
#line 93 "../src/projects/buildtask.vala"
				_g_object_unref0 (_tmp43_);
#line 83 "../src/projects/buildtask.vala"
				_g_free0 (arg);
#line 985 "buildtask.c"
			}
		}
	}
	{
		gchar** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
#line 96 "../src/projects/buildtask.vala"
		arg_collection = generated_sources;
#line 96 "../src/projects/buildtask.vala"
		arg_collection_length1 = generated_sources_length1;
#line 96 "../src/projects/buildtask.vala"
		for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
#line 1000 "buildtask.c"
			gchar* _tmp44_;
			gchar* arg = NULL;
#line 96 "../src/projects/buildtask.vala"
			_tmp44_ = g_strdup (arg_collection[arg_it]);
#line 96 "../src/projects/buildtask.vala"
			arg = _tmp44_;
#line 1007 "buildtask.c"
			{
				const gchar* _tmp45_;
				gchar* _tmp46_;
				GeeArrayList* _tmp47_;
				GeeArrayList* _tmp48_;
				const gchar* _tmp49_;
				GFile* _tmp50_;
				GFile* _tmp51_;
#line 97 "../src/projects/buildtask.vala"
				_tmp45_ = arg;
#line 97 "../src/projects/buildtask.vala"
				_tmp46_ = g_strdup (_tmp45_);
#line 97 "../src/projects/buildtask.vala"
				_vala_array_add19 (&self->priv->arguments, &self->priv->arguments_length1, &self->priv->_arguments_size_, _tmp46_);
#line 98 "../src/projects/buildtask.vala"
				_tmp47_ = vls_build_target_get_input ((VlsBuildTarget*) self);
#line 98 "../src/projects/buildtask.vala"
				_tmp48_ = _tmp47_;
#line 98 "../src/projects/buildtask.vala"
				_tmp49_ = arg;
#line 98 "../src/projects/buildtask.vala"
				_tmp50_ = g_file_new_for_commandline_arg_and_cwd (_tmp49_, output_dir);
#line 98 "../src/projects/buildtask.vala"
				_tmp51_ = _tmp50_;
#line 98 "../src/projects/buildtask.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp48_, _tmp51_);
#line 98 "../src/projects/buildtask.vala"
				_g_object_unref0 (_tmp51_);
#line 96 "../src/projects/buildtask.vala"
				_g_free0 (arg);
#line 1038 "buildtask.c"
			}
		}
	}
#line 101 "../src/projects/buildtask.vala"
	if (compiler_length1 > 0) {
#line 1044 "buildtask.c"
		const gchar* _tmp53_;
		gchar* _tmp54_;
#line 101 "../src/projects/buildtask.vala"
		_tmp53_ = compiler[0];
#line 101 "../src/projects/buildtask.vala"
		_tmp54_ = g_path_get_basename (_tmp53_);
#line 101 "../src/projects/buildtask.vala"
		_g_free0 (_tmp52_);
#line 101 "../src/projects/buildtask.vala"
		_tmp52_ = _tmp54_;
#line 1055 "buildtask.c"
	} else {
#line 101 "../src/projects/buildtask.vala"
		_g_free0 (_tmp52_);
#line 101 "../src/projects/buildtask.vala"
		_tmp52_ = NULL;
#line 1061 "buildtask.c"
	}
#line 101 "../src/projects/buildtask.vala"
	_tmp55_ = g_strdup (_tmp52_);
#line 101 "../src/projects/buildtask.vala"
	cmd_basename = _tmp55_;
#line 103 "../src/projects/buildtask.vala"
	_tmp56_ = cmd_basename;
#line 103 "../src/projects/buildtask.vala"
	if (g_strcmp0 (_tmp56_, "vapigen") == 0) {
#line 1071 "buildtask.c"
		gchar* library_name = NULL;
		gchar* directory = NULL;
		gchar* flag_name = NULL;
		gchar* arg_value = NULL;
		const gchar* _tmp69_;
#line 104 "../src/projects/buildtask.vala"
		library_name = NULL;
#line 105 "../src/projects/buildtask.vala"
		directory = NULL;
#line 1081 "buildtask.c"
		{
			gint arg_i = 0;
#line 109 "../src/projects/buildtask.vala"
			arg_i = -1;
#line 1086 "buildtask.c"
			{
				gboolean _tmp57_ = FALSE;
#line 109 "../src/projects/buildtask.vala"
				_tmp57_ = TRUE;
#line 109 "../src/projects/buildtask.vala"
				while (TRUE) {
#line 1093 "buildtask.c"
					gchar** _tmp58_;
					gint _tmp58__length1;
					gchar* _tmp59_ = NULL;
					gchar* _tmp60_ = NULL;
					gint _tmp61_;
					gchar** _tmp62_;
					gint _tmp62__length1;
					const gchar* _tmp63_;
#line 109 "../src/projects/buildtask.vala"
					if (!_tmp57_) {
#line 1104 "buildtask.c"
					}
#line 109 "../src/projects/buildtask.vala"
					_tmp57_ = FALSE;
#line 109 "../src/projects/buildtask.vala"
					_tmp58_ = self->priv->arguments;
#line 109 "../src/projects/buildtask.vala"
					_tmp58__length1 = self->priv->arguments_length1;
#line 109 "../src/projects/buildtask.vala"
					_tmp61_ = vls_util_iterate_valac_args (_tmp58_, (gint) _tmp58__length1, &_tmp59_, &_tmp60_, arg_i);
#line 109 "../src/projects/buildtask.vala"
					_g_free0 (flag_name);
#line 109 "../src/projects/buildtask.vala"
					flag_name = _tmp59_;
#line 109 "../src/projects/buildtask.vala"
					_g_free0 (arg_value);
#line 109 "../src/projects/buildtask.vala"
					arg_value = _tmp60_;
#line 109 "../src/projects/buildtask.vala"
					arg_i = _tmp61_;
#line 109 "../src/projects/buildtask.vala"
					_tmp62_ = self->priv->arguments;
#line 109 "../src/projects/buildtask.vala"
					_tmp62__length1 = self->priv->arguments_length1;
#line 109 "../src/projects/buildtask.vala"
					if (!(arg_i < _tmp62__length1)) {
#line 109 "../src/projects/buildtask.vala"
						break;
#line 1132 "buildtask.c"
					}
#line 110 "../src/projects/buildtask.vala"
					_tmp63_ = flag_name;
#line 110 "../src/projects/buildtask.vala"
					if (g_strcmp0 (_tmp63_, "directory") == 0) {
#line 1138 "buildtask.c"
						const gchar* _tmp64_;
						gchar* _tmp65_;
#line 111 "../src/projects/buildtask.vala"
						_tmp64_ = arg_value;
#line 111 "../src/projects/buildtask.vala"
						_tmp65_ = g_strdup (_tmp64_);
#line 111 "../src/projects/buildtask.vala"
						_g_free0 (directory);
#line 111 "../src/projects/buildtask.vala"
						directory = _tmp65_;
#line 1149 "buildtask.c"
					} else {
						const gchar* _tmp66_;
#line 112 "../src/projects/buildtask.vala"
						_tmp66_ = flag_name;
#line 112 "../src/projects/buildtask.vala"
						if (g_strcmp0 (_tmp66_, "library") == 0) {
#line 1156 "buildtask.c"
							const gchar* _tmp67_;
							gchar* _tmp68_;
#line 113 "../src/projects/buildtask.vala"
							_tmp67_ = arg_value;
#line 113 "../src/projects/buildtask.vala"
							_tmp68_ = g_strdup (_tmp67_);
#line 113 "../src/projects/buildtask.vala"
							_g_free0 (library_name);
#line 113 "../src/projects/buildtask.vala"
							library_name = _tmp68_;
#line 1167 "buildtask.c"
						}
					}
				}
			}
		}
#line 116 "../src/projects/buildtask.vala"
		_tmp69_ = library_name;
#line 116 "../src/projects/buildtask.vala"
		if (_tmp69_ != NULL) {
#line 1177 "buildtask.c"
			const gchar* _tmp70_;
			GeeArrayList* _tmp72_;
			GeeArrayList* _tmp73_;
			const gchar* _tmp74_;
			const gchar* _tmp75_;
			gchar* _tmp76_;
			gchar* _tmp77_;
			const gchar* _tmp78_;
			GFile* _tmp79_;
			GFile* _tmp80_;
#line 117 "../src/projects/buildtask.vala"
			_tmp70_ = directory;
#line 117 "../src/projects/buildtask.vala"
			if (_tmp70_ == NULL) {
#line 1192 "buildtask.c"
				gchar* _tmp71_;
#line 118 "../src/projects/buildtask.vala"
				g_warning ("buildtask.vala:118: BuildTask(%s): no --directory for vapigen, assumin" \
"g %s", id, output_dir);
#line 119 "../src/projects/buildtask.vala"
				_tmp71_ = g_strdup (output_dir);
#line 119 "../src/projects/buildtask.vala"
				_g_free0 (directory);
#line 119 "../src/projects/buildtask.vala"
				directory = _tmp71_;
#line 1202 "buildtask.c"
			}
#line 121 "../src/projects/buildtask.vala"
			_tmp72_ = vls_build_target_get_output ((VlsBuildTarget*) self);
#line 121 "../src/projects/buildtask.vala"
			_tmp73_ = _tmp72_;
#line 121 "../src/projects/buildtask.vala"
			_tmp74_ = library_name;
#line 121 "../src/projects/buildtask.vala"
			_tmp75_ = string_to_string (_tmp74_);
#line 121 "../src/projects/buildtask.vala"
			_tmp76_ = g_strconcat (_tmp75_, ".vapi", NULL);
#line 121 "../src/projects/buildtask.vala"
			_tmp77_ = _tmp76_;
#line 121 "../src/projects/buildtask.vala"
			_tmp78_ = directory;
#line 121 "../src/projects/buildtask.vala"
			_tmp79_ = g_file_new_for_commandline_arg_and_cwd (_tmp77_, _tmp78_);
#line 121 "../src/projects/buildtask.vala"
			_tmp80_ = _tmp79_;
#line 121 "../src/projects/buildtask.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp73_, _tmp80_);
#line 121 "../src/projects/buildtask.vala"
			_g_object_unref0 (_tmp80_);
#line 121 "../src/projects/buildtask.vala"
			_g_free0 (_tmp77_);
#line 1228 "buildtask.c"
		}
#line 103 "../src/projects/buildtask.vala"
		_g_free0 (arg_value);
#line 103 "../src/projects/buildtask.vala"
		_g_free0 (flag_name);
#line 103 "../src/projects/buildtask.vala"
		_g_free0 (directory);
#line 103 "../src/projects/buildtask.vala"
		_g_free0 (library_name);
#line 1238 "buildtask.c"
	} else {
		{
			gchar** output_filename_collection = NULL;
			gint output_filename_collection_length1 = 0;
			gint _output_filename_collection_size_ = 0;
			gint output_filename_it = 0;
#line 125 "../src/projects/buildtask.vala"
			output_filename_collection = target_output_files;
#line 125 "../src/projects/buildtask.vala"
			output_filename_collection_length1 = target_output_files_length1;
#line 125 "../src/projects/buildtask.vala"
			for (output_filename_it = 0; output_filename_it < output_filename_collection_length1; output_filename_it = output_filename_it + 1) {
#line 1251 "buildtask.c"
				gchar* _tmp81_;
				gchar* output_filename = NULL;
#line 125 "../src/projects/buildtask.vala"
				_tmp81_ = g_strdup (output_filename_collection[output_filename_it]);
#line 125 "../src/projects/buildtask.vala"
				output_filename = _tmp81_;
#line 1258 "buildtask.c"
				{
					const gchar* _tmp82_;
#line 126 "../src/projects/buildtask.vala"
					_tmp82_ = output_filename;
#line 126 "../src/projects/buildtask.vala"
					if (_tmp82_ != NULL) {
#line 1265 "buildtask.c"
						GeeArrayList* _tmp83_;
						GeeArrayList* _tmp84_;
						const gchar* _tmp85_;
						GFile* _tmp86_;
						GFile* _tmp87_;
						const gchar* _tmp88_;
#line 127 "../src/projects/buildtask.vala"
						_tmp83_ = vls_build_target_get_output ((VlsBuildTarget*) self);
#line 127 "../src/projects/buildtask.vala"
						_tmp84_ = _tmp83_;
#line 127 "../src/projects/buildtask.vala"
						_tmp85_ = output_filename;
#line 127 "../src/projects/buildtask.vala"
						_tmp86_ = g_file_new_for_commandline_arg_and_cwd (_tmp85_, output_dir);
#line 127 "../src/projects/buildtask.vala"
						_tmp87_ = _tmp86_;
#line 127 "../src/projects/buildtask.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp84_, _tmp87_);
#line 127 "../src/projects/buildtask.vala"
						_g_object_unref0 (_tmp87_);
#line 128 "../src/projects/buildtask.vala"
						_tmp88_ = output_filename;
#line 128 "../src/projects/buildtask.vala"
						g_debug ("buildtask.vala:128: BuildTask(%s): outputs %s", id, _tmp88_);
#line 1290 "buildtask.c"
					}
#line 125 "../src/projects/buildtask.vala"
					_g_free0 (output_filename);
#line 1294 "buildtask.c"
				}
			}
		}
	}
#line 133 "../src/projects/buildtask.vala"
	_tmp91_ = cmd_basename;
#line 133 "../src/projects/buildtask.vala"
	if (g_strcmp0 (_tmp91_, "glib-mkenums") == 0) {
#line 133 "../src/projects/buildtask.vala"
		_tmp90_ = TRUE;
#line 1305 "buildtask.c"
	} else {
		const gchar* _tmp92_;
#line 134 "../src/projects/buildtask.vala"
		_tmp92_ = cmd_basename;
#line 134 "../src/projects/buildtask.vala"
		_tmp90_ = g_strcmp0 (_tmp92_, "g-ir-scanner") == 0;
#line 1312 "buildtask.c"
	}
#line 133 "../src/projects/buildtask.vala"
	if (_tmp90_) {
#line 133 "../src/projects/buildtask.vala"
		_tmp89_ = TRUE;
#line 1318 "buildtask.c"
	} else {
		const gchar* _tmp93_;
#line 135 "../src/projects/buildtask.vala"
		_tmp93_ = cmd_basename;
#line 135 "../src/projects/buildtask.vala"
		_tmp89_ = g_strcmp0 (_tmp93_, "glib-compile-resources") == 0;
#line 1325 "buildtask.c"
	}
#line 133 "../src/projects/buildtask.vala"
	if (_tmp89_) {
#line 1329 "buildtask.c"
		GFile* output_file = NULL;
		const gchar* _tmp116_;
#line 138 "../src/projects/buildtask.vala"
		if (target_output_files_length1 >= 1) {
#line 1334 "buildtask.c"
			const gchar* _tmp94_;
			GFile* _tmp95_;
			gboolean _tmp96_ = FALSE;
			const gchar* _tmp97_;
#line 139 "../src/projects/buildtask.vala"
			_tmp94_ = target_output_files[0];
#line 139 "../src/projects/buildtask.vala"
			_tmp95_ = g_file_new_for_path (_tmp94_);
#line 139 "../src/projects/buildtask.vala"
			_g_object_unref0 (output_file);
#line 139 "../src/projects/buildtask.vala"
			output_file = _tmp95_;
#line 142 "../src/projects/buildtask.vala"
			_tmp97_ = cmd_basename;
#line 142 "../src/projects/buildtask.vala"
			if (g_strcmp0 (_tmp97_, "glib-mkenums") == 0) {
#line 1351 "buildtask.c"
				const gchar* _tmp98_;
#line 142 "../src/projects/buildtask.vala"
				_tmp98_ = target_output_files[0];
#line 142 "../src/projects/buildtask.vala"
				_tmp96_ = g_str_has_suffix (_tmp98_, ".c");
#line 1357 "buildtask.c"
			} else {
#line 142 "../src/projects/buildtask.vala"
				_tmp96_ = FALSE;
#line 1361 "buildtask.c"
			}
#line 142 "../src/projects/buildtask.vala"
			if (_tmp96_) {
#line 1365 "buildtask.c"
				GeeArrayList* _tmp99_;
				GeeArrayList* _tmp100_;
				const gchar* _tmp101_;
				const gchar* _tmp102_;
				gint _tmp103_;
				gint _tmp104_;
				gchar* _tmp105_;
				gchar* _tmp106_;
				gchar* _tmp107_;
				gchar* _tmp108_;
				GFile* _tmp109_;
				GFile* _tmp110_;
#line 143 "../src/projects/buildtask.vala"
				_tmp99_ = vls_build_target_get_input ((VlsBuildTarget*) self);
#line 143 "../src/projects/buildtask.vala"
				_tmp100_ = _tmp99_;
#line 143 "../src/projects/buildtask.vala"
				_tmp101_ = target_output_files[0];
#line 143 "../src/projects/buildtask.vala"
				_tmp102_ = target_output_files[0];
#line 143 "../src/projects/buildtask.vala"
				_tmp103_ = strlen (_tmp102_);
#line 143 "../src/projects/buildtask.vala"
				_tmp104_ = _tmp103_;
#line 143 "../src/projects/buildtask.vala"
				_tmp105_ = string_substring (_tmp101_, (glong) 0, (glong) (_tmp104_ - 2));
#line 143 "../src/projects/buildtask.vala"
				_tmp106_ = _tmp105_;
#line 143 "../src/projects/buildtask.vala"
				_tmp107_ = g_strconcat (_tmp106_, ".h", NULL);
#line 143 "../src/projects/buildtask.vala"
				_tmp108_ = _tmp107_;
#line 143 "../src/projects/buildtask.vala"
				_tmp109_ = g_file_new_for_path (_tmp108_);
#line 143 "../src/projects/buildtask.vala"
				_tmp110_ = _tmp109_;
#line 143 "../src/projects/buildtask.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp100_, _tmp110_);
#line 143 "../src/projects/buildtask.vala"
				_g_object_unref0 (_tmp110_);
#line 143 "../src/projects/buildtask.vala"
				_g_free0 (_tmp108_);
#line 143 "../src/projects/buildtask.vala"
				_g_free0 (_tmp106_);
#line 1410 "buildtask.c"
			}
		} else {
			const gchar* _tmp111_;
			gchar* _tmp112_;
			gchar* _tmp113_;
			GError* _tmp114_;
			GError* _tmp115_;
#line 145 "../src/projects/buildtask.vala"
			_tmp111_ = string_to_string (id);
#line 145 "../src/projects/buildtask.vala"
			_tmp112_ = g_strconcat ("BuildTask(", _tmp111_, ") expected at least one output file for target", NULL);
#line 145 "../src/projects/buildtask.vala"
			_tmp113_ = _tmp112_;
#line 145 "../src/projects/buildtask.vala"
			_tmp114_ = g_error_new_literal (VLS_PROJECT_ERROR, VLS_PROJECT_ERROR_INTROSPECTION, _tmp113_);
#line 145 "../src/projects/buildtask.vala"
			_tmp115_ = _tmp114_;
#line 145 "../src/projects/buildtask.vala"
			_g_free0 (_tmp113_);
#line 145 "../src/projects/buildtask.vala"
			_inner_error0_ = _tmp115_;
#line 145 "../src/projects/buildtask.vala"
			g_propagate_error (error, _inner_error0_);
#line 145 "../src/projects/buildtask.vala"
			_g_object_unref0 (output_file);
#line 145 "../src/projects/buildtask.vala"
			_g_free0 (cmd_basename);
#line 145 "../src/projects/buildtask.vala"
			_g_free0 (_tmp52_);
#line 145 "../src/projects/buildtask.vala"
			_g_object_unref0 (self);
#line 145 "../src/projects/buildtask.vala"
			return NULL;
#line 1444 "buildtask.c"
		}
#line 148 "../src/projects/buildtask.vala"
		_tmp116_ = cmd_basename;
#line 148 "../src/projects/buildtask.vala"
		if (g_strcmp0 (_tmp116_, "g-ir-scanner") == 0) {
#line 1450 "buildtask.c"
			gchar* last_arg = NULL;
			gchar* gir_library_name = NULL;
			GFile* gir_library_dir = NULL;
			GFile* _tmp117_;
			GFile* _tmp118_;
			gchar** _tmp119_;
			gint _tmp119__length1;
			const gchar* _tmp126_;
#line 150 "../src/projects/buildtask.vala"
			last_arg = NULL;
#line 151 "../src/projects/buildtask.vala"
			gir_library_name = NULL;
#line 152 "../src/projects/buildtask.vala"
			_tmp117_ = output_file;
#line 152 "../src/projects/buildtask.vala"
			_tmp118_ = g_file_get_parent (_tmp117_);
#line 152 "../src/projects/buildtask.vala"
			gir_library_dir = _tmp118_;
#line 153 "../src/projects/buildtask.vala"
			_tmp119_ = self->priv->arguments;
#line 153 "../src/projects/buildtask.vala"
			_tmp119__length1 = self->priv->arguments_length1;
#line 1473 "buildtask.c"
			{
				gchar** arg_collection = NULL;
				gint arg_collection_length1 = 0;
				gint _arg_collection_size_ = 0;
				gint arg_it = 0;
#line 153 "../src/projects/buildtask.vala"
				arg_collection = _tmp119_;
#line 153 "../src/projects/buildtask.vala"
				arg_collection_length1 = _tmp119__length1;
#line 153 "../src/projects/buildtask.vala"
				for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
#line 1485 "buildtask.c"
					gchar* _tmp120_;
					gchar* arg = NULL;
#line 153 "../src/projects/buildtask.vala"
					_tmp120_ = g_strdup (arg_collection[arg_it]);
#line 153 "../src/projects/buildtask.vala"
					arg = _tmp120_;
#line 1492 "buildtask.c"
					{
						const gchar* _tmp121_;
						const gchar* _tmp124_;
						gchar* _tmp125_;
#line 154 "../src/projects/buildtask.vala"
						_tmp121_ = last_arg;
#line 154 "../src/projects/buildtask.vala"
						if (g_strcmp0 (_tmp121_, "--library") == 0) {
#line 1501 "buildtask.c"
							const gchar* _tmp122_;
							gchar* _tmp123_;
#line 155 "../src/projects/buildtask.vala"
							_tmp122_ = arg;
#line 155 "../src/projects/buildtask.vala"
							_tmp123_ = g_strdup (_tmp122_);
#line 155 "../src/projects/buildtask.vala"
							_g_free0 (gir_library_name);
#line 155 "../src/projects/buildtask.vala"
							gir_library_name = _tmp123_;
#line 1512 "buildtask.c"
						}
#line 156 "../src/projects/buildtask.vala"
						_tmp124_ = arg;
#line 156 "../src/projects/buildtask.vala"
						_tmp125_ = g_strdup (_tmp124_);
#line 156 "../src/projects/buildtask.vala"
						_g_free0 (last_arg);
#line 156 "../src/projects/buildtask.vala"
						last_arg = _tmp125_;
#line 153 "../src/projects/buildtask.vala"
						_g_free0 (arg);
#line 1524 "buildtask.c"
					}
				}
			}
#line 159 "../src/projects/buildtask.vala"
			_tmp126_ = gir_library_name;
#line 159 "../src/projects/buildtask.vala"
			if (_tmp126_ != NULL) {
#line 1532 "buildtask.c"
				GFile* _tmp127_;
#line 160 "../src/projects/buildtask.vala"
				_tmp127_ = gir_library_dir;
#line 160 "../src/projects/buildtask.vala"
				if (_tmp127_ != NULL) {
#line 1538 "buildtask.c"
					GeeArrayList* tried = NULL;
					GeeArrayList* _tmp128_;
					gboolean success = FALSE;
					GFile* library_file = NULL;
					gchar* _tmp129_;
					gchar* _tmp130_;
					gchar** _tmp131_;
#line 162 "../src/projects/buildtask.vala"
					_tmp128_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 162 "../src/projects/buildtask.vala"
					if (_tmp128_) {
#line 162 "../src/projects/buildtask.vala"
						g_object_set_data ((GObject *) _tmp128_, "vala-creation-function", "Vls.BuildTask.new");
#line 1552 "buildtask.c"
					}
#line 162 "../src/projects/buildtask.vala"
					tried = _tmp128_;
#line 163 "../src/projects/buildtask.vala"
					success = FALSE;
#line 164 "../src/projects/buildtask.vala"
					library_file = NULL;
#line 165 "../src/projects/buildtask.vala"
					_tmp129_ = g_strdup ("so");
#line 165 "../src/projects/buildtask.vala"
					_tmp130_ = g_strdup ("dll");
#line 165 "../src/projects/buildtask.vala"
					_tmp131_ = g_new0 (gchar*, 2 + 1);
#line 165 "../src/projects/buildtask.vala"
					_tmp131_[0] = _tmp129_;
#line 165 "../src/projects/buildtask.vala"
					_tmp131_[1] = _tmp130_;
#line 1570 "buildtask.c"
					{
						gchar** shlib_suffix_collection = NULL;
						gint shlib_suffix_collection_length1 = 0;
						gint _shlib_suffix_collection_size_ = 0;
						gint shlib_suffix_it = 0;
#line 165 "../src/projects/buildtask.vala"
						shlib_suffix_collection = _tmp131_;
#line 165 "../src/projects/buildtask.vala"
						shlib_suffix_collection_length1 = 2;
#line 165 "../src/projects/buildtask.vala"
						for (shlib_suffix_it = 0; shlib_suffix_it < shlib_suffix_collection_length1; shlib_suffix_it = shlib_suffix_it + 1) {
#line 1582 "buildtask.c"
							gchar* _tmp132_;
							gchar* shlib_suffix = NULL;
#line 165 "../src/projects/buildtask.vala"
							_tmp132_ = g_strdup (shlib_suffix_collection[shlib_suffix_it]);
#line 165 "../src/projects/buildtask.vala"
							shlib_suffix = _tmp132_;
#line 1589 "buildtask.c"
							{
								GFile* _tmp133_;
								const gchar* _tmp134_;
								const gchar* _tmp135_;
								const gchar* _tmp136_;
								const gchar* _tmp137_;
								gchar* _tmp138_;
								gchar* _tmp139_;
								GFile* _tmp140_;
								GFile* _tmp141_;
								GFile* libdir = NULL;
								GFile* _tmp148_;
								const gchar* _tmp149_;
								const gchar* _tmp150_;
								const gchar* _tmp151_;
								const gchar* _tmp152_;
								gchar* _tmp153_;
								gchar* _tmp154_;
								GFile* _tmp155_;
								GFile* _tmp156_;
								GFile* _tmp157_;
								GeeArrayList* _tmp164_;
								GFile* _tmp165_;
#line 166 "../src/projects/buildtask.vala"
								_tmp133_ = gir_library_dir;
#line 166 "../src/projects/buildtask.vala"
								_tmp134_ = gir_library_name;
#line 166 "../src/projects/buildtask.vala"
								_tmp135_ = string_to_string (_tmp134_);
#line 166 "../src/projects/buildtask.vala"
								_tmp136_ = shlib_suffix;
#line 166 "../src/projects/buildtask.vala"
								_tmp137_ = string_to_string (_tmp136_);
#line 166 "../src/projects/buildtask.vala"
								_tmp138_ = g_strconcat ("lib", _tmp135_, ".", _tmp137_, NULL);
#line 166 "../src/projects/buildtask.vala"
								_tmp139_ = _tmp138_;
#line 166 "../src/projects/buildtask.vala"
								_tmp140_ = g_file_get_child (_tmp133_, _tmp139_);
#line 166 "../src/projects/buildtask.vala"
								_g_object_unref0 (library_file);
#line 166 "../src/projects/buildtask.vala"
								library_file = _tmp140_;
#line 166 "../src/projects/buildtask.vala"
								_g_free0 (_tmp139_);
#line 167 "../src/projects/buildtask.vala"
								_tmp141_ = library_file;
#line 167 "../src/projects/buildtask.vala"
								if (g_file_query_exists (_tmp141_, NULL)) {
#line 1639 "buildtask.c"
									GeeArrayList* _tmp142_;
									GeeArrayList* _tmp143_;
									GFile* _tmp144_;
									GFile* _tmp145_;
									gchar* _tmp146_;
									gchar* _tmp147_;
#line 168 "../src/projects/buildtask.vala"
									_tmp142_ = vls_build_target_get_input ((VlsBuildTarget*) self);
#line 168 "../src/projects/buildtask.vala"
									_tmp143_ = _tmp142_;
#line 168 "../src/projects/buildtask.vala"
									_tmp144_ = library_file;
#line 168 "../src/projects/buildtask.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp143_, _tmp144_);
#line 169 "../src/projects/buildtask.vala"
									_tmp145_ = library_file;
#line 169 "../src/projects/buildtask.vala"
									_tmp146_ = g_file_get_path (_tmp145_);
#line 169 "../src/projects/buildtask.vala"
									_tmp147_ = _tmp146_;
#line 169 "../src/projects/buildtask.vala"
									g_debug ("buildtask.vala:169: BuildTask(%s) found input %s", id, _tmp147_);
#line 169 "../src/projects/buildtask.vala"
									_g_free0 (_tmp147_);
#line 170 "../src/projects/buildtask.vala"
									success = TRUE;
#line 171 "../src/projects/buildtask.vala"
									_g_free0 (shlib_suffix);
#line 171 "../src/projects/buildtask.vala"
									break;
#line 1670 "buildtask.c"
								}
#line 176 "../src/projects/buildtask.vala"
								_tmp148_ = gir_library_dir;
#line 176 "../src/projects/buildtask.vala"
								_tmp149_ = gir_library_name;
#line 176 "../src/projects/buildtask.vala"
								_tmp150_ = string_to_string (_tmp149_);
#line 176 "../src/projects/buildtask.vala"
								_tmp151_ = shlib_suffix;
#line 176 "../src/projects/buildtask.vala"
								_tmp152_ = string_to_string (_tmp151_);
#line 176 "../src/projects/buildtask.vala"
								_tmp153_ = g_strconcat ("lib", _tmp150_, ".", _tmp152_, ".p", NULL);
#line 176 "../src/projects/buildtask.vala"
								_tmp154_ = _tmp153_;
#line 176 "../src/projects/buildtask.vala"
								_tmp155_ = g_file_get_child (_tmp148_, _tmp154_);
#line 176 "../src/projects/buildtask.vala"
								_tmp156_ = _tmp155_;
#line 176 "../src/projects/buildtask.vala"
								_g_free0 (_tmp154_);
#line 176 "../src/projects/buildtask.vala"
								libdir = _tmp156_;
#line 177 "../src/projects/buildtask.vala"
								_tmp157_ = libdir;
#line 177 "../src/projects/buildtask.vala"
								if (g_file_query_exists (_tmp157_, NULL)) {
#line 1698 "buildtask.c"
									GeeArrayList* _tmp158_;
									GeeArrayList* _tmp159_;
									GFile* _tmp160_;
									GFile* _tmp161_;
									gchar* _tmp162_;
									gchar* _tmp163_;
#line 178 "../src/projects/buildtask.vala"
									_tmp158_ = vls_build_target_get_input ((VlsBuildTarget*) self);
#line 178 "../src/projects/buildtask.vala"
									_tmp159_ = _tmp158_;
#line 178 "../src/projects/buildtask.vala"
									_tmp160_ = library_file;
#line 178 "../src/projects/buildtask.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp159_, _tmp160_);
#line 179 "../src/projects/buildtask.vala"
									_tmp161_ = library_file;
#line 179 "../src/projects/buildtask.vala"
									_tmp162_ = g_file_get_path (_tmp161_);
#line 179 "../src/projects/buildtask.vala"
									_tmp163_ = _tmp162_;
#line 179 "../src/projects/buildtask.vala"
									g_debug ("buildtask.vala:179: BuildTask(%s) found input %s", id, _tmp163_);
#line 179 "../src/projects/buildtask.vala"
									_g_free0 (_tmp163_);
#line 180 "../src/projects/buildtask.vala"
									success = TRUE;
#line 181 "../src/projects/buildtask.vala"
									_g_object_unref0 (libdir);
#line 181 "../src/projects/buildtask.vala"
									_g_free0 (shlib_suffix);
#line 181 "../src/projects/buildtask.vala"
									break;
#line 1731 "buildtask.c"
								}
#line 184 "../src/projects/buildtask.vala"
								_tmp164_ = tried;
#line 184 "../src/projects/buildtask.vala"
								_tmp165_ = library_file;
#line 184 "../src/projects/buildtask.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp164_, _tmp165_);
#line 165 "../src/projects/buildtask.vala"
								_g_object_unref0 (libdir);
#line 165 "../src/projects/buildtask.vala"
								_g_free0 (shlib_suffix);
#line 1743 "buildtask.c"
							}
						}
#line 165 "../src/projects/buildtask.vala"
						shlib_suffix_collection = (_vala_array_free (shlib_suffix_collection, shlib_suffix_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1748 "buildtask.c"
					}
#line 186 "../src/projects/buildtask.vala"
					if (!success) {
#line 1752 "buildtask.c"
						GeeArrayList* _tmp166_;
						GeeIterator* _tmp167_;
						GeeIterator* _tmp168_;
						gchar* _tmp169_;
						gpointer _tmp170_;
						gchar* _tmp171_;
#line 187 "../src/projects/buildtask.vala"
						_tmp166_ = tried;
#line 187 "../src/projects/buildtask.vala"
						_tmp167_ = gee_traversable_map ((GeeTraversable*) _tmp166_, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ________lambda12__gee_map_func, self);
#line 187 "../src/projects/buildtask.vala"
						_tmp168_ = _tmp167_;
#line 187 "../src/projects/buildtask.vala"
						_tmp169_ = g_strdup ("");
#line 187 "../src/projects/buildtask.vala"
						_tmp170_ = gee_traversable_fold ((GeeTraversable*) _tmp168_, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ________lambda13__gee_fold_func, self, _tmp169_);
#line 187 "../src/projects/buildtask.vala"
						_tmp171_ = (gchar*) _tmp170_;
#line 187 "../src/projects/buildtask.vala"
						g_warning ("buildtask.vala:187: BuildTask(%s) failed to determine g-ir-scanner inp" \
"ut because all options don't exist (tried %s)", id, _tmp171_);
#line 187 "../src/projects/buildtask.vala"
						_g_free0 (_tmp171_);
#line 187 "../src/projects/buildtask.vala"
						_g_object_unref0 (_tmp168_);
#line 1777 "buildtask.c"
					} else {
						GFile* real_file = NULL;
						GFile* _tmp172_;
						GFile* _tmp173_;
#line 195 "../src/projects/buildtask.vala"
						_tmp172_ = library_file;
#line 195 "../src/projects/buildtask.vala"
						_tmp173_ = _g_object_ref0 (_tmp172_);
#line 195 "../src/projects/buildtask.vala"
						real_file = _tmp173_;
#line 1788 "buildtask.c"
						{
							GFileInfo* info = NULL;
							GFile* _tmp174_;
							GFileInfo* _tmp175_;
							gboolean _tmp185_ = FALSE;
							gboolean _tmp186_ = FALSE;
							GFileInfo* _tmp187_;
#line 197 "../src/projects/buildtask.vala"
							_tmp174_ = real_file;
#line 197 "../src/projects/buildtask.vala"
							_tmp175_ = g_file_query_info (_tmp174_, "standard::*", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 197 "../src/projects/buildtask.vala"
							info = _tmp175_;
#line 197 "../src/projects/buildtask.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1804 "buildtask.c"
								goto __catch0_g_error;
							}
#line 200 "../src/projects/buildtask.vala"
							while (TRUE) {
#line 1809 "buildtask.c"
								GFileInfo* _tmp176_;
								GFile* _tmp177_;
								GFileInfo* _tmp178_;
								const gchar* _tmp179_;
								GFile* _tmp180_;
#line 200 "../src/projects/buildtask.vala"
								_tmp176_ = info;
#line 200 "../src/projects/buildtask.vala"
								if (!g_file_info_get_is_symlink (_tmp176_)) {
#line 200 "../src/projects/buildtask.vala"
									break;
#line 1821 "buildtask.c"
								}
#line 201 "../src/projects/buildtask.vala"
								_tmp177_ = gir_library_dir;
#line 201 "../src/projects/buildtask.vala"
								_tmp178_ = info;
#line 201 "../src/projects/buildtask.vala"
								_tmp179_ = g_file_info_get_symlink_target (_tmp178_);
#line 201 "../src/projects/buildtask.vala"
								_tmp180_ = g_file_get_child (_tmp177_, _tmp179_);
#line 201 "../src/projects/buildtask.vala"
								_g_object_unref0 (real_file);
#line 201 "../src/projects/buildtask.vala"
								real_file = _tmp180_;
#line 1835 "buildtask.c"
								{
									GFileInfo* _tmp181_ = NULL;
									GFile* _tmp182_;
									GFileInfo* _tmp183_;
									GFileInfo* _tmp184_;
#line 203 "../src/projects/buildtask.vala"
									_tmp182_ = real_file;
#line 203 "../src/projects/buildtask.vala"
									_tmp183_ = g_file_query_info (_tmp182_, "standard::*", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 203 "../src/projects/buildtask.vala"
									_tmp181_ = _tmp183_;
#line 203 "../src/projects/buildtask.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1849 "buildtask.c"
										goto __catch1_g_error;
									}
#line 203 "../src/projects/buildtask.vala"
									_tmp184_ = _tmp181_;
#line 203 "../src/projects/buildtask.vala"
									_tmp181_ = NULL;
#line 203 "../src/projects/buildtask.vala"
									_g_object_unref0 (info);
#line 203 "../src/projects/buildtask.vala"
									info = _tmp184_;
#line 202 "../src/projects/buildtask.vala"
									_g_object_unref0 (_tmp181_);
#line 1862 "buildtask.c"
								}
								goto __finally1;
								__catch1_g_error:
								{
#line 202 "../src/projects/buildtask.vala"
									g_clear_error (&_inner_error0_);
#line 207 "../src/projects/buildtask.vala"
									_g_object_unref0 (info);
#line 207 "../src/projects/buildtask.vala"
									info = NULL;
#line 208 "../src/projects/buildtask.vala"
									break;
#line 1875 "buildtask.c"
								}
								__finally1:
#line 202 "../src/projects/buildtask.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 202 "../src/projects/buildtask.vala"
									_g_object_unref0 (info);
#line 1882 "buildtask.c"
									goto __catch0_g_error;
								}
							}
#line 211 "../src/projects/buildtask.vala"
							_tmp187_ = info;
#line 211 "../src/projects/buildtask.vala"
							if (_tmp187_ == NULL) {
#line 211 "../src/projects/buildtask.vala"
								_tmp186_ = TRUE;
#line 1892 "buildtask.c"
							} else {
								GFileInfo* _tmp188_;
#line 211 "../src/projects/buildtask.vala"
								_tmp188_ = info;
#line 211 "../src/projects/buildtask.vala"
								_tmp186_ = !g_file_info_get_is_symlink (_tmp188_);
#line 1899 "buildtask.c"
							}
#line 211 "../src/projects/buildtask.vala"
							if (_tmp186_) {
#line 1903 "buildtask.c"
								GFile* _tmp189_;
								GFile* _tmp190_;
#line 211 "../src/projects/buildtask.vala"
								_tmp189_ = real_file;
#line 211 "../src/projects/buildtask.vala"
								_tmp190_ = library_file;
#line 211 "../src/projects/buildtask.vala"
								_tmp185_ = _tmp189_ != _tmp190_;
#line 1912 "buildtask.c"
							} else {
#line 211 "../src/projects/buildtask.vala"
								_tmp185_ = FALSE;
#line 1916 "buildtask.c"
							}
#line 211 "../src/projects/buildtask.vala"
							if (_tmp185_) {
#line 1920 "buildtask.c"
								GeeArrayList* _tmp191_;
								GeeArrayList* _tmp192_;
								GFile* _tmp193_;
								GFile* _tmp194_;
								gchar* _tmp195_;
								gchar* _tmp196_;
#line 212 "../src/projects/buildtask.vala"
								_tmp191_ = vls_build_target_get_input ((VlsBuildTarget*) self);
#line 212 "../src/projects/buildtask.vala"
								_tmp192_ = _tmp191_;
#line 212 "../src/projects/buildtask.vala"
								_tmp193_ = real_file;
#line 212 "../src/projects/buildtask.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp192_, _tmp193_);
#line 213 "../src/projects/buildtask.vala"
								_tmp194_ = real_file;
#line 213 "../src/projects/buildtask.vala"
								_tmp195_ = g_file_get_path (_tmp194_);
#line 213 "../src/projects/buildtask.vala"
								_tmp196_ = _tmp195_;
#line 213 "../src/projects/buildtask.vala"
								g_debug ("buildtask.vala:213: BuildTask(%s): found input from symlink - %s", id, _tmp196_);
#line 213 "../src/projects/buildtask.vala"
								_g_free0 (_tmp196_);
#line 1945 "buildtask.c"
							}
#line 196 "../src/projects/buildtask.vala"
							_g_object_unref0 (info);
#line 1949 "buildtask.c"
						}
						goto __finally0;
						__catch0_g_error:
						{
#line 196 "../src/projects/buildtask.vala"
							g_clear_error (&_inner_error0_);
#line 1956 "buildtask.c"
						}
						__finally0:
#line 196 "../src/projects/buildtask.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 196 "../src/projects/buildtask.vala"
							g_propagate_error (error, _inner_error0_);
#line 196 "../src/projects/buildtask.vala"
							_g_object_unref0 (real_file);
#line 196 "../src/projects/buildtask.vala"
							_g_object_unref0 (library_file);
#line 196 "../src/projects/buildtask.vala"
							_g_object_unref0 (tried);
#line 196 "../src/projects/buildtask.vala"
							_g_object_unref0 (gir_library_dir);
#line 196 "../src/projects/buildtask.vala"
							_g_free0 (gir_library_name);
#line 196 "../src/projects/buildtask.vala"
							_g_free0 (last_arg);
#line 196 "../src/projects/buildtask.vala"
							_g_object_unref0 (output_file);
#line 196 "../src/projects/buildtask.vala"
							_g_free0 (cmd_basename);
#line 196 "../src/projects/buildtask.vala"
							_g_free0 (_tmp52_);
#line 196 "../src/projects/buildtask.vala"
							_g_object_unref0 (self);
#line 196 "../src/projects/buildtask.vala"
							return NULL;
#line 1985 "buildtask.c"
						}
#line 186 "../src/projects/buildtask.vala"
						_g_object_unref0 (real_file);
#line 1989 "buildtask.c"
					}
#line 160 "../src/projects/buildtask.vala"
					_g_object_unref0 (library_file);
#line 160 "../src/projects/buildtask.vala"
					_g_object_unref0 (tried);
#line 1995 "buildtask.c"
				} else {
#line 221 "../src/projects/buildtask.vala"
					g_warning ("buildtask.vala:221: BuildTask(%s): could not get directory for .gir fi" \
"le", id);
#line 1999 "buildtask.c"
				}
			} else {
#line 224 "../src/projects/buildtask.vala"
				g_warning ("buildtask.vala:224: BuildTask(%s): could not get library for g-ir-scan" \
"ner task", id);
#line 2004 "buildtask.c"
			}
#line 148 "../src/projects/buildtask.vala"
			_g_object_unref0 (gir_library_dir);
#line 148 "../src/projects/buildtask.vala"
			_g_free0 (gir_library_name);
#line 148 "../src/projects/buildtask.vala"
			_g_free0 (last_arg);
#line 2012 "buildtask.c"
		} else {
			const gchar* _tmp197_;
#line 226 "../src/projects/buildtask.vala"
			_tmp197_ = cmd_basename;
#line 226 "../src/projects/buildtask.vala"
			if (g_strcmp0 (_tmp197_, "glib-compile-resources") == 0) {
#line 2019 "buildtask.c"
				GFile** source_dirs = NULL;
				GFile** _tmp198_;
				gint source_dirs_length1;
				gint _source_dirs_size_;
				gchar* last_arg = NULL;
				gchar** _tmp199_;
				gint _tmp199__length1;
#line 227 "../src/projects/buildtask.vala"
				_tmp198_ = g_new0 (GFile*, 0 + 1);
#line 227 "../src/projects/buildtask.vala"
				source_dirs = _tmp198_;
#line 227 "../src/projects/buildtask.vala"
				source_dirs_length1 = 0;
#line 227 "../src/projects/buildtask.vala"
				_source_dirs_size_ = source_dirs_length1;
#line 228 "../src/projects/buildtask.vala"
				last_arg = NULL;
#line 230 "../src/projects/buildtask.vala"
				_tmp199_ = self->priv->arguments;
#line 230 "../src/projects/buildtask.vala"
				_tmp199__length1 = self->priv->arguments_length1;
#line 2041 "buildtask.c"
				{
					gchar** arg_collection = NULL;
					gint arg_collection_length1 = 0;
					gint _arg_collection_size_ = 0;
					gint arg_it = 0;
#line 230 "../src/projects/buildtask.vala"
					arg_collection = _tmp199_;
#line 230 "../src/projects/buildtask.vala"
					arg_collection_length1 = _tmp199__length1;
#line 230 "../src/projects/buildtask.vala"
					for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
#line 2053 "buildtask.c"
						gchar* _tmp200_;
						gchar* arg = NULL;
#line 230 "../src/projects/buildtask.vala"
						_tmp200_ = g_strdup (arg_collection[arg_it]);
#line 230 "../src/projects/buildtask.vala"
						arg = _tmp200_;
#line 2060 "buildtask.c"
						{
							const gchar* _tmp201_;
							const gchar* _tmp204_;
							gchar* _tmp205_;
#line 231 "../src/projects/buildtask.vala"
							_tmp201_ = last_arg;
#line 231 "../src/projects/buildtask.vala"
							if (g_strcmp0 (_tmp201_, "--sourcedir") == 0) {
#line 2069 "buildtask.c"
								const gchar* _tmp202_;
								GFile* _tmp203_;
#line 232 "../src/projects/buildtask.vala"
								_tmp202_ = arg;
#line 232 "../src/projects/buildtask.vala"
								_tmp203_ = g_file_new_for_commandline_arg_and_cwd (_tmp202_, output_dir);
#line 232 "../src/projects/buildtask.vala"
								_vala_array_add20 (&source_dirs, &source_dirs_length1, &_source_dirs_size_, _tmp203_);
#line 2078 "buildtask.c"
							}
#line 233 "../src/projects/buildtask.vala"
							_tmp204_ = arg;
#line 233 "../src/projects/buildtask.vala"
							_tmp205_ = g_strdup (_tmp204_);
#line 233 "../src/projects/buildtask.vala"
							_g_free0 (last_arg);
#line 233 "../src/projects/buildtask.vala"
							last_arg = _tmp205_;
#line 230 "../src/projects/buildtask.vala"
							_g_free0 (arg);
#line 2090 "buildtask.c"
						}
					}
				}
				{
					GeeArrayList* _input_file_list = NULL;
					GeeArrayList* _tmp206_;
					GeeArrayList* _tmp207_;
					gint _input_file_size = 0;
					GeeArrayList* _tmp208_;
					gint _tmp209_;
					gint _tmp210_;
					gint _input_file_index = 0;
#line 236 "../src/projects/buildtask.vala"
					_tmp206_ = vls_build_target_get_input ((VlsBuildTarget*) self);
#line 236 "../src/projects/buildtask.vala"
					_tmp207_ = _tmp206_;
#line 236 "../src/projects/buildtask.vala"
					_input_file_list = _tmp207_;
#line 236 "../src/projects/buildtask.vala"
					_tmp208_ = _input_file_list;
#line 236 "../src/projects/buildtask.vala"
					_tmp209_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp208_);
#line 236 "../src/projects/buildtask.vala"
					_tmp210_ = _tmp209_;
#line 236 "../src/projects/buildtask.vala"
					_input_file_size = _tmp210_;
#line 236 "../src/projects/buildtask.vala"
					_input_file_index = -1;
#line 236 "../src/projects/buildtask.vala"
					while (TRUE) {
#line 2121 "buildtask.c"
						gint _tmp211_;
						gint _tmp212_;
						GFile* input_file = NULL;
						GeeArrayList* _tmp213_;
						gpointer _tmp214_;
						GFile* _tmp215_;
						gchar* _tmp216_;
						gchar* _tmp217_;
						gboolean _tmp218_;
						gchar* gresources_xml = NULL;
						GFile* _tmp219_;
						gchar* _tmp220_;
						gchar* _tmp221_;
						gchar* _tmp222_ = NULL;
						GFile** potential_gresources = NULL;
						const gchar* _tmp223_;
						GFile** _tmp224_;
						gint _tmp224__length1;
						gint _tmp225_ = 0;
						GFile** _tmp226_;
						gint potential_gresources_length1;
						gint _potential_gresources_size_;
						GeeArrayList* _tmp227_;
						GFile** _tmp228_;
						gint _tmp228__length1;
						GeeArrayList* _tmp229_;
						GFile** _tmp230_;
						gint _tmp230__length1;
#line 236 "../src/projects/buildtask.vala"
						_input_file_index = _input_file_index + 1;
#line 236 "../src/projects/buildtask.vala"
						_tmp211_ = _input_file_index;
#line 236 "../src/projects/buildtask.vala"
						_tmp212_ = _input_file_size;
#line 236 "../src/projects/buildtask.vala"
						if (!(_tmp211_ < _tmp212_)) {
#line 236 "../src/projects/buildtask.vala"
							break;
#line 2160 "buildtask.c"
						}
#line 236 "../src/projects/buildtask.vala"
						_tmp213_ = _input_file_list;
#line 236 "../src/projects/buildtask.vala"
						_tmp214_ = gee_abstract_list_get ((GeeAbstractList*) _tmp213_, _input_file_index);
#line 236 "../src/projects/buildtask.vala"
						input_file = (GFile*) _tmp214_;
#line 237 "../src/projects/buildtask.vala"
						_tmp215_ = input_file;
#line 237 "../src/projects/buildtask.vala"
						_tmp216_ = g_file_get_path (_tmp215_);
#line 237 "../src/projects/buildtask.vala"
						_tmp217_ = _tmp216_;
#line 237 "../src/projects/buildtask.vala"
						_tmp218_ = !g_str_has_suffix (_tmp217_, ".gresources.xml");
#line 237 "../src/projects/buildtask.vala"
						_g_free0 (_tmp217_);
#line 237 "../src/projects/buildtask.vala"
						if (_tmp218_) {
#line 238 "../src/projects/buildtask.vala"
							_g_object_unref0 (input_file);
#line 238 "../src/projects/buildtask.vala"
							break;
#line 2184 "buildtask.c"
						}
#line 241 "../src/projects/buildtask.vala"
						_tmp219_ = input_file;
#line 241 "../src/projects/buildtask.vala"
						_tmp220_ = g_file_get_path (_tmp219_);
#line 241 "../src/projects/buildtask.vala"
						_tmp221_ = _tmp220_;
#line 241 "../src/projects/buildtask.vala"
						g_file_get_contents (_tmp221_, &_tmp222_, NULL, &_inner_error0_);
#line 241 "../src/projects/buildtask.vala"
						_g_free0 (gresources_xml);
#line 241 "../src/projects/buildtask.vala"
						gresources_xml = _tmp222_;
#line 241 "../src/projects/buildtask.vala"
						_g_free0 (_tmp221_);
#line 241 "../src/projects/buildtask.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 241 "../src/projects/buildtask.vala"
							g_propagate_error (error, _inner_error0_);
#line 241 "../src/projects/buildtask.vala"
							_g_free0 (gresources_xml);
#line 241 "../src/projects/buildtask.vala"
							_g_object_unref0 (input_file);
#line 241 "../src/projects/buildtask.vala"
							_g_free0 (last_arg);
#line 241 "../src/projects/buildtask.vala"
							source_dirs = (_vala_array_free (source_dirs, source_dirs_length1, (GDestroyNotify) g_object_unref), NULL);
#line 241 "../src/projects/buildtask.vala"
							_g_object_unref0 (output_file);
#line 241 "../src/projects/buildtask.vala"
							_g_free0 (cmd_basename);
#line 241 "../src/projects/buildtask.vala"
							_g_free0 (_tmp52_);
#line 241 "../src/projects/buildtask.vala"
							_g_object_unref0 (self);
#line 241 "../src/projects/buildtask.vala"
							return NULL;
#line 2222 "buildtask.c"
						}
#line 242 "../src/projects/buildtask.vala"
						_tmp223_ = gresources_xml;
#line 242 "../src/projects/buildtask.vala"
						_tmp224_ = source_dirs;
#line 242 "../src/projects/buildtask.vala"
						_tmp224__length1 = source_dirs_length1;
#line 242 "../src/projects/buildtask.vala"
						_tmp226_ = vls_util_discover_gresources_xml_input_files (_tmp223_, _tmp224_, (gint) _tmp224__length1, &_tmp225_, &_inner_error0_);
#line 242 "../src/projects/buildtask.vala"
						potential_gresources = _tmp226_;
#line 242 "../src/projects/buildtask.vala"
						potential_gresources_length1 = _tmp225_;
#line 242 "../src/projects/buildtask.vala"
						_potential_gresources_size_ = potential_gresources_length1;
#line 242 "../src/projects/buildtask.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 242 "../src/projects/buildtask.vala"
							g_propagate_error (error, _inner_error0_);
#line 242 "../src/projects/buildtask.vala"
							_g_free0 (gresources_xml);
#line 242 "../src/projects/buildtask.vala"
							_g_object_unref0 (input_file);
#line 242 "../src/projects/buildtask.vala"
							_g_free0 (last_arg);
#line 242 "../src/projects/buildtask.vala"
							source_dirs = (_vala_array_free (source_dirs, source_dirs_length1, (GDestroyNotify) g_object_unref), NULL);
#line 242 "../src/projects/buildtask.vala"
							_g_object_unref0 (output_file);
#line 242 "../src/projects/buildtask.vala"
							_g_free0 (cmd_basename);
#line 242 "../src/projects/buildtask.vala"
							_g_free0 (_tmp52_);
#line 242 "../src/projects/buildtask.vala"
							_g_object_unref0 (self);
#line 242 "../src/projects/buildtask.vala"
							return NULL;
#line 2260 "buildtask.c"
						}
#line 243 "../src/projects/buildtask.vala"
						_tmp227_ = self->priv->_candidate_inputs;
#line 243 "../src/projects/buildtask.vala"
						_tmp228_ = potential_gresources;
#line 243 "../src/projects/buildtask.vala"
						_tmp228__length1 = potential_gresources_length1;
#line 243 "../src/projects/buildtask.vala"
						gee_collection_add_all_array ((GeeCollection*) _tmp227_, _tmp228_, (gint) _tmp228__length1);
#line 244 "../src/projects/buildtask.vala"
						_tmp229_ = self->priv->_used_files;
#line 244 "../src/projects/buildtask.vala"
						_tmp230_ = potential_gresources;
#line 244 "../src/projects/buildtask.vala"
						_tmp230__length1 = potential_gresources_length1;
#line 244 "../src/projects/buildtask.vala"
						gee_collection_add_all_array ((GeeCollection*) _tmp229_, _tmp230_, (gint) _tmp230__length1);
#line 236 "../src/projects/buildtask.vala"
						potential_gresources = (_vala_array_free (potential_gresources, potential_gresources_length1, (GDestroyNotify) g_object_unref), NULL);
#line 236 "../src/projects/buildtask.vala"
						_g_free0 (gresources_xml);
#line 236 "../src/projects/buildtask.vala"
						_g_object_unref0 (input_file);
#line 2284 "buildtask.c"
					}
				}
#line 226 "../src/projects/buildtask.vala"
				_g_free0 (last_arg);
#line 226 "../src/projects/buildtask.vala"
				source_dirs = (_vala_array_free (source_dirs, source_dirs_length1, (GDestroyNotify) g_object_unref), NULL);
#line 2291 "buildtask.c"
			}
		}
#line 133 "../src/projects/buildtask.vala"
		_g_object_unref0 (output_file);
#line 2296 "buildtask.c"
	}
#line 45 "../src/projects/buildtask.vala"
	_g_free0 (cmd_basename);
#line 45 "../src/projects/buildtask.vala"
	_g_free0 (_tmp52_);
#line 45 "../src/projects/buildtask.vala"
	return self;
#line 2304 "buildtask.c"
}

VlsBuildTask*
vls_build_task_new (VlsFileCache* file_cache,
                    const gchar* build_dir,
                    const gchar* output_dir,
                    const gchar* name,
                    const gchar* id,
                    gint no,
                    gchar** compiler,
                    gint compiler_length1,
                    gchar** args,
                    gint args_length1,
                    gchar** sources,
                    gint sources_length1,
                    gchar** generated_sources,
                    gint generated_sources_length1,
                    gchar** target_output_files,
                    gint target_output_files_length1,
                    const gchar* language,
                    GError** error)
{
#line 45 "../src/projects/buildtask.vala"
	return vls_build_task_construct (VLS_TYPE_BUILD_TASK, file_cache, build_dir, output_dir, name, id, no, compiler, compiler_length1, args, args_length1, sources, sources_length1, generated_sources, generated_sources_length1, target_output_files, target_output_files_length1, language, error);
#line 2329 "buildtask.c"
}

static void
vls_build_task_real_build_if_stale (VlsBuildTarget* base,
                                    GCancellable* cancellable,
                                    GError** error)
{
	VlsBuildTask * self;
	gboolean _tmp0_ = FALSE;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GSubprocess* process = NULL;
	GSubprocessLauncher* _tmp31_;
	gchar** _tmp32_;
	gint _tmp32__length1;
	GSubprocess* _tmp33_;
	GSubprocess* _tmp34_;
	GError* _inner_error0_ = NULL;
#line 250 "../src/projects/buildtask.vala"
	self = (VlsBuildTask*) base;
#line 252 "../src/projects/buildtask.vala"
	_tmp1_ = vls_build_target_get_input ((VlsBuildTarget*) self);
#line 252 "../src/projects/buildtask.vala"
	_tmp2_ = _tmp1_;
#line 252 "../src/projects/buildtask.vala"
	_tmp3_ = gee_collection_get_is_empty ((GeeCollection*) _tmp2_);
#line 252 "../src/projects/buildtask.vala"
	_tmp4_ = _tmp3_;
#line 252 "../src/projects/buildtask.vala"
	if (!_tmp4_) {
#line 2362 "buildtask.c"
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 252 "../src/projects/buildtask.vala"
		_tmp5_ = vls_build_target_get_output ((VlsBuildTarget*) self);
#line 252 "../src/projects/buildtask.vala"
		_tmp6_ = _tmp5_;
#line 252 "../src/projects/buildtask.vala"
		_tmp7_ = gee_collection_get_is_empty ((GeeCollection*) _tmp6_);
#line 252 "../src/projects/buildtask.vala"
		_tmp8_ = _tmp7_;
#line 252 "../src/projects/buildtask.vala"
		_tmp0_ = !_tmp8_;
#line 2377 "buildtask.c"
	} else {
#line 252 "../src/projects/buildtask.vala"
		_tmp0_ = FALSE;
#line 2381 "buildtask.c"
	}
#line 252 "../src/projects/buildtask.vala"
	if (_tmp0_) {
#line 2385 "buildtask.c"
		gboolean inputs_modified_after = FALSE;
#line 253 "../src/projects/buildtask.vala"
		inputs_modified_after = FALSE;
#line 2389 "buildtask.c"
		{
			GeeArrayList* _file_list = NULL;
			GeeArrayList* _tmp9_;
			GeeArrayList* _tmp10_;
			gint _file_size = 0;
			GeeArrayList* _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _file_index = 0;
#line 255 "../src/projects/buildtask.vala"
			_tmp9_ = vls_build_target_get_input ((VlsBuildTarget*) self);
#line 255 "../src/projects/buildtask.vala"
			_tmp10_ = _tmp9_;
#line 255 "../src/projects/buildtask.vala"
			_file_list = _tmp10_;
#line 255 "../src/projects/buildtask.vala"
			_tmp11_ = _file_list;
#line 255 "../src/projects/buildtask.vala"
			_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 255 "../src/projects/buildtask.vala"
			_tmp13_ = _tmp12_;
#line 255 "../src/projects/buildtask.vala"
			_file_size = _tmp13_;
#line 255 "../src/projects/buildtask.vala"
			_file_index = -1;
#line 255 "../src/projects/buildtask.vala"
			while (TRUE) {
#line 2417 "buildtask.c"
				gint _tmp14_;
				gint _tmp15_;
				GFile* file = NULL;
				GeeArrayList* _tmp16_;
				gpointer _tmp17_;
				GFileInfo* info = NULL;
				GFile* _tmp18_;
				GFileInfo* _tmp19_;
				GDateTime* file_last_modified = NULL;
				GFileInfo* _tmp20_;
				GDateTime* _tmp21_;
				GDateTime* _tmp22_;
#line 255 "../src/projects/buildtask.vala"
				_file_index = _file_index + 1;
#line 255 "../src/projects/buildtask.vala"
				_tmp14_ = _file_index;
#line 255 "../src/projects/buildtask.vala"
				_tmp15_ = _file_size;
#line 255 "../src/projects/buildtask.vala"
				if (!(_tmp14_ < _tmp15_)) {
#line 255 "../src/projects/buildtask.vala"
					break;
#line 2440 "buildtask.c"
				}
#line 255 "../src/projects/buildtask.vala"
				_tmp16_ = _file_list;
#line 255 "../src/projects/buildtask.vala"
				_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _file_index);
#line 255 "../src/projects/buildtask.vala"
				file = (GFile*) _tmp17_;
#line 256 "../src/projects/buildtask.vala"
				_tmp18_ = file;
#line 256 "../src/projects/buildtask.vala"
				_tmp19_ = g_file_query_info (_tmp18_, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NONE, cancellable, &_inner_error0_);
#line 256 "../src/projects/buildtask.vala"
				info = _tmp19_;
#line 256 "../src/projects/buildtask.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 256 "../src/projects/buildtask.vala"
					g_propagate_error (error, _inner_error0_);
#line 256 "../src/projects/buildtask.vala"
					_g_object_unref0 (file);
#line 256 "../src/projects/buildtask.vala"
					return;
#line 2462 "buildtask.c"
				}
#line 259 "../src/projects/buildtask.vala"
				_tmp20_ = info;
#line 259 "../src/projects/buildtask.vala"
				_tmp21_ = g_file_info_get_modification_date_time (_tmp20_);
#line 259 "../src/projects/buildtask.vala"
				_g_date_time_unref0 (file_last_modified);
#line 259 "../src/projects/buildtask.vala"
				file_last_modified = _tmp21_;
#line 264 "../src/projects/buildtask.vala"
				_tmp22_ = file_last_modified;
#line 264 "../src/projects/buildtask.vala"
				if (_tmp22_ == NULL) {
#line 2476 "buildtask.c"
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					GFile* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
#line 265 "../src/projects/buildtask.vala"
					_tmp23_ = vls_build_target_get_id ((VlsBuildTarget*) self);
#line 265 "../src/projects/buildtask.vala"
					_tmp24_ = _tmp23_;
#line 265 "../src/projects/buildtask.vala"
					_tmp25_ = file;
#line 265 "../src/projects/buildtask.vala"
					_tmp26_ = g_file_get_path (_tmp25_);
#line 265 "../src/projects/buildtask.vala"
					_tmp27_ = _tmp26_;
#line 265 "../src/projects/buildtask.vala"
					g_warning ("buildtask.vala:265: BuildTask(%s) could not get last modified time of " \
"%s", _tmp24_, _tmp27_);
#line 265 "../src/projects/buildtask.vala"
					_g_free0 (_tmp27_);
#line 2496 "buildtask.c"
				} else {
					GDateTime* _tmp28_;
					GDateTime* _tmp29_;
					GDateTime* _tmp30_;
#line 266 "../src/projects/buildtask.vala"
					_tmp28_ = file_last_modified;
#line 266 "../src/projects/buildtask.vala"
					_tmp29_ = vls_build_target_get_last_updated ((VlsBuildTarget*) self);
#line 266 "../src/projects/buildtask.vala"
					_tmp30_ = _tmp29_;
#line 266 "../src/projects/buildtask.vala"
					if (g_date_time_compare (_tmp28_, _tmp30_) > 0) {
#line 267 "../src/projects/buildtask.vala"
						inputs_modified_after = TRUE;
#line 268 "../src/projects/buildtask.vala"
						_g_date_time_unref0 (file_last_modified);
#line 268 "../src/projects/buildtask.vala"
						_g_object_unref0 (info);
#line 268 "../src/projects/buildtask.vala"
						_g_object_unref0 (file);
#line 268 "../src/projects/buildtask.vala"
						break;
#line 2519 "buildtask.c"
					}
				}
#line 255 "../src/projects/buildtask.vala"
				_g_date_time_unref0 (file_last_modified);
#line 255 "../src/projects/buildtask.vala"
				_g_object_unref0 (info);
#line 255 "../src/projects/buildtask.vala"
				_g_object_unref0 (file);
#line 2528 "buildtask.c"
			}
		}
#line 272 "../src/projects/buildtask.vala"
		if (!inputs_modified_after) {
#line 273 "../src/projects/buildtask.vala"
			return;
#line 2535 "buildtask.c"
		}
	}
#line 276 "../src/projects/buildtask.vala"
	_tmp31_ = self->priv->launcher;
#line 276 "../src/projects/buildtask.vala"
	_tmp32_ = self->priv->arguments;
#line 276 "../src/projects/buildtask.vala"
	_tmp32__length1 = self->priv->arguments_length1;
#line 276 "../src/projects/buildtask.vala"
	_tmp33_ = g_subprocess_launcher_spawnv (_tmp31_, _tmp32_, &_inner_error0_);
#line 276 "../src/projects/buildtask.vala"
	process = _tmp33_;
#line 276 "../src/projects/buildtask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 276 "../src/projects/buildtask.vala"
		g_propagate_error (error, _inner_error0_);
#line 276 "../src/projects/buildtask.vala"
		return;
#line 2554 "buildtask.c"
	}
#line 277 "../src/projects/buildtask.vala"
	_tmp34_ = process;
#line 277 "../src/projects/buildtask.vala"
	g_subprocess_wait (_tmp34_, cancellable, &_inner_error0_);
#line 277 "../src/projects/buildtask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 277 "../src/projects/buildtask.vala"
		g_propagate_error (error, _inner_error0_);
#line 277 "../src/projects/buildtask.vala"
		_g_object_unref0 (process);
#line 277 "../src/projects/buildtask.vala"
		return;
#line 2568 "buildtask.c"
	}
#line 278 "../src/projects/buildtask.vala"
	if (g_cancellable_is_cancelled (cancellable)) {
#line 2572 "buildtask.c"
		GSubprocess* _tmp35_;
#line 279 "../src/projects/buildtask.vala"
		_tmp35_ = process;
#line 279 "../src/projects/buildtask.vala"
		g_subprocess_force_exit (_tmp35_);
#line 280 "../src/projects/buildtask.vala"
		g_cancellable_set_error_if_cancelled (cancellable, &_inner_error0_);
#line 280 "../src/projects/buildtask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 280 "../src/projects/buildtask.vala"
			g_propagate_error (error, _inner_error0_);
#line 280 "../src/projects/buildtask.vala"
			_g_object_unref0 (process);
#line 280 "../src/projects/buildtask.vala"
			return;
#line 2588 "buildtask.c"
		}
	} else {
		GSubprocess* _tmp36_;
#line 281 "../src/projects/buildtask.vala"
		_tmp36_ = process;
#line 281 "../src/projects/buildtask.vala"
		if (!g_subprocess_get_successful (_tmp36_)) {
#line 2596 "buildtask.c"
			gchar* failed_msg = NULL;
			gchar* _tmp37_;
			GSubprocess* _tmp38_;
			const gchar* _tmp58_;
#line 282 "../src/projects/buildtask.vala"
			_tmp37_ = g_strdup ("");
#line 282 "../src/projects/buildtask.vala"
			failed_msg = _tmp37_;
#line 283 "../src/projects/buildtask.vala"
			_tmp38_ = process;
#line 283 "../src/projects/buildtask.vala"
			if (g_subprocess_get_if_exited (_tmp38_)) {
#line 2609 "buildtask.c"
				const gchar* _tmp39_;
				const gchar* _tmp40_;
				const gchar* _tmp41_;
				const gchar* _tmp42_;
				const gchar* _tmp43_;
				GSubprocess* _tmp44_;
				gchar* _tmp45_;
				gchar* _tmp46_;
				const gchar* _tmp47_;
				const gchar* _tmp48_;
				gchar* _tmp49_;
#line 284 "../src/projects/buildtask.vala"
				_tmp39_ = vls_build_target_get_id ((VlsBuildTarget*) self);
#line 284 "../src/projects/buildtask.vala"
				_tmp40_ = _tmp39_;
#line 284 "../src/projects/buildtask.vala"
				_tmp41_ = string_to_string (_tmp40_);
#line 284 "../src/projects/buildtask.vala"
				_tmp42_ = self->priv->exe_name;
#line 284 "../src/projects/buildtask.vala"
				_tmp43_ = string_to_string (_tmp42_);
#line 284 "../src/projects/buildtask.vala"
				_tmp44_ = process;
#line 284 "../src/projects/buildtask.vala"
				_tmp45_ = g_strdup_printf ("%i", g_subprocess_get_exit_status (_tmp44_));
#line 284 "../src/projects/buildtask.vala"
				_tmp46_ = _tmp45_;
#line 284 "../src/projects/buildtask.vala"
				_tmp47_ = self->priv->build_dir;
#line 284 "../src/projects/buildtask.vala"
				_tmp48_ = string_to_string (_tmp47_);
#line 284 "../src/projects/buildtask.vala"
				_tmp49_ = g_strconcat ("BuildTask(", _tmp41_, ") `", _tmp43_, "' returned with status ", _tmp46_, " (launched from ", _tmp48_, ")", NULL);
#line 284 "../src/projects/buildtask.vala"
				_g_free0 (failed_msg);
#line 284 "../src/projects/buildtask.vala"
				failed_msg = _tmp49_;
#line 284 "../src/projects/buildtask.vala"
				_g_free0 (_tmp46_);
#line 2649 "buildtask.c"
			} else {
				const gchar* _tmp50_;
				const gchar* _tmp51_;
				const gchar* _tmp52_;
				const gchar* _tmp53_;
				const gchar* _tmp54_;
				const gchar* _tmp55_;
				const gchar* _tmp56_;
				gchar* _tmp57_;
#line 286 "../src/projects/buildtask.vala"
				_tmp50_ = vls_build_target_get_id ((VlsBuildTarget*) self);
#line 286 "../src/projects/buildtask.vala"
				_tmp51_ = _tmp50_;
#line 286 "../src/projects/buildtask.vala"
				_tmp52_ = string_to_string (_tmp51_);
#line 286 "../src/projects/buildtask.vala"
				_tmp53_ = self->priv->exe_name;
#line 286 "../src/projects/buildtask.vala"
				_tmp54_ = string_to_string (_tmp53_);
#line 286 "../src/projects/buildtask.vala"
				_tmp55_ = self->priv->build_dir;
#line 286 "../src/projects/buildtask.vala"
				_tmp56_ = string_to_string (_tmp55_);
#line 286 "../src/projects/buildtask.vala"
				_tmp57_ = g_strconcat ("BuildTask(", _tmp52_, ") `", _tmp54_, "' terminated (launched from ", _tmp56_, ")", NULL);
#line 286 "../src/projects/buildtask.vala"
				_g_free0 (failed_msg);
#line 286 "../src/projects/buildtask.vala"
				failed_msg = _tmp57_;
#line 2679 "buildtask.c"
			}
#line 295 "../src/projects/buildtask.vala"
			_tmp58_ = failed_msg;
#line 295 "../src/projects/buildtask.vala"
			g_warning ("buildtask.vala:295: %s", _tmp58_);
#line 281 "../src/projects/buildtask.vala"
			_g_free0 (failed_msg);
#line 2687 "buildtask.c"
		} else {
			gboolean _tmp59_ = FALSE;
			GeeArrayList* _tmp60_;
			GeeArrayList* _tmp61_;
			gint _tmp62_;
			gint _tmp63_;
			GTimeZone* _tmp90_;
			GTimeZone* _tmp91_;
			GDateTime* _tmp92_;
			GDateTime* _tmp93_;
#line 297 "../src/projects/buildtask.vala"
			_tmp60_ = vls_build_target_get_output ((VlsBuildTarget*) self);
#line 297 "../src/projects/buildtask.vala"
			_tmp61_ = _tmp60_;
#line 297 "../src/projects/buildtask.vala"
			_tmp62_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp61_);
#line 297 "../src/projects/buildtask.vala"
			_tmp63_ = _tmp62_;
#line 297 "../src/projects/buildtask.vala"
			if (_tmp63_ == 1) {
#line 2708 "buildtask.c"
				GeeArrayList* _tmp64_;
				GeeArrayList* _tmp65_;
				gpointer _tmp66_;
				GFile* _tmp67_;
#line 297 "../src/projects/buildtask.vala"
				_tmp64_ = vls_build_target_get_output ((VlsBuildTarget*) self);
#line 297 "../src/projects/buildtask.vala"
				_tmp65_ = _tmp64_;
#line 297 "../src/projects/buildtask.vala"
				_tmp66_ = gee_abstract_list_get ((GeeAbstractList*) _tmp65_, 0);
#line 297 "../src/projects/buildtask.vala"
				_tmp67_ = (GFile*) _tmp66_;
#line 297 "../src/projects/buildtask.vala"
				_tmp59_ = !g_file_query_exists (_tmp67_, cancellable);
#line 297 "../src/projects/buildtask.vala"
				_g_object_unref0 (_tmp67_);
#line 2725 "buildtask.c"
			} else {
#line 297 "../src/projects/buildtask.vala"
				_tmp59_ = FALSE;
#line 2729 "buildtask.c"
			}
#line 297 "../src/projects/buildtask.vala"
			if (_tmp59_) {
#line 2733 "buildtask.c"
				GFile* output_file = NULL;
				GeeArrayList* _tmp68_;
				GeeArrayList* _tmp69_;
				gpointer _tmp70_;
				GInputStream* process_output_istream = NULL;
				GSubprocess* _tmp71_;
				GInputStream* _tmp72_;
				GInputStream* _tmp73_;
				GInputStream* _tmp74_;
#line 299 "../src/projects/buildtask.vala"
				_tmp68_ = vls_build_target_get_output ((VlsBuildTarget*) self);
#line 299 "../src/projects/buildtask.vala"
				_tmp69_ = _tmp68_;
#line 299 "../src/projects/buildtask.vala"
				_tmp70_ = gee_abstract_list_get ((GeeAbstractList*) _tmp69_, 0);
#line 299 "../src/projects/buildtask.vala"
				output_file = (GFile*) _tmp70_;
#line 300 "../src/projects/buildtask.vala"
				_tmp71_ = process;
#line 300 "../src/projects/buildtask.vala"
				_tmp72_ = g_subprocess_get_stdout_pipe (_tmp71_);
#line 300 "../src/projects/buildtask.vala"
				_tmp73_ = _g_object_ref0 (_tmp72_);
#line 300 "../src/projects/buildtask.vala"
				process_output_istream = _tmp73_;
#line 301 "../src/projects/buildtask.vala"
				_tmp74_ = process_output_istream;
#line 301 "../src/projects/buildtask.vala"
				if (_tmp74_ != NULL) {
#line 2763 "buildtask.c"
					GFileOutputStream* outfile_ostream = NULL;
					GFile* _tmp75_;
					GFileOutputStream* _tmp76_;
					GFileOutputStream* _tmp77_;
					GInputStream* _tmp78_;
#line 302 "../src/projects/buildtask.vala"
					_tmp75_ = output_file;
#line 302 "../src/projects/buildtask.vala"
					_tmp76_ = g_file_replace (_tmp75_, NULL, FALSE, G_FILE_CREATE_NONE, cancellable, &_inner_error0_);
#line 302 "../src/projects/buildtask.vala"
					outfile_ostream = _tmp76_;
#line 302 "../src/projects/buildtask.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 302 "../src/projects/buildtask.vala"
						g_propagate_error (error, _inner_error0_);
#line 302 "../src/projects/buildtask.vala"
						_g_object_unref0 (process_output_istream);
#line 302 "../src/projects/buildtask.vala"
						_g_object_unref0 (output_file);
#line 302 "../src/projects/buildtask.vala"
						_g_object_unref0 (process);
#line 302 "../src/projects/buildtask.vala"
						return;
#line 2787 "buildtask.c"
					}
#line 303 "../src/projects/buildtask.vala"
					_tmp77_ = outfile_ostream;
#line 303 "../src/projects/buildtask.vala"
					_tmp78_ = process_output_istream;
#line 303 "../src/projects/buildtask.vala"
					g_output_stream_splice ((GOutputStream*) _tmp77_, _tmp78_, G_OUTPUT_STREAM_SPLICE_NONE, cancellable, &_inner_error0_);
#line 303 "../src/projects/buildtask.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 303 "../src/projects/buildtask.vala"
						g_propagate_error (error, _inner_error0_);
#line 303 "../src/projects/buildtask.vala"
						_g_object_unref0 (outfile_ostream);
#line 303 "../src/projects/buildtask.vala"
						_g_object_unref0 (process_output_istream);
#line 303 "../src/projects/buildtask.vala"
						_g_object_unref0 (output_file);
#line 303 "../src/projects/buildtask.vala"
						_g_object_unref0 (process);
#line 303 "../src/projects/buildtask.vala"
						return;
#line 2809 "buildtask.c"
					}
#line 301 "../src/projects/buildtask.vala"
					_g_object_unref0 (outfile_ostream);
#line 2813 "buildtask.c"
				}
#line 297 "../src/projects/buildtask.vala"
				_g_object_unref0 (process_output_istream);
#line 297 "../src/projects/buildtask.vala"
				_g_object_unref0 (output_file);
#line 2819 "buildtask.c"
			}
			{
				GeeArrayList* _file_list = NULL;
				GeeArrayList* _tmp79_;
				GeeArrayList* _tmp80_;
				gint _file_size = 0;
				GeeArrayList* _tmp81_;
				gint _tmp82_;
				gint _tmp83_;
				gint _file_index = 0;
#line 307 "../src/projects/buildtask.vala"
				_tmp79_ = vls_build_target_get_output ((VlsBuildTarget*) self);
#line 307 "../src/projects/buildtask.vala"
				_tmp80_ = _tmp79_;
#line 307 "../src/projects/buildtask.vala"
				_file_list = _tmp80_;
#line 307 "../src/projects/buildtask.vala"
				_tmp81_ = _file_list;
#line 307 "../src/projects/buildtask.vala"
				_tmp82_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp81_);
#line 307 "../src/projects/buildtask.vala"
				_tmp83_ = _tmp82_;
#line 307 "../src/projects/buildtask.vala"
				_file_size = _tmp83_;
#line 307 "../src/projects/buildtask.vala"
				_file_index = -1;
#line 307 "../src/projects/buildtask.vala"
				while (TRUE) {
#line 2848 "buildtask.c"
					gint _tmp84_;
					gint _tmp85_;
					GFile* file = NULL;
					GeeArrayList* _tmp86_;
					gpointer _tmp87_;
					VlsFileCache* _tmp88_;
					GFile* _tmp89_;
#line 307 "../src/projects/buildtask.vala"
					_file_index = _file_index + 1;
#line 307 "../src/projects/buildtask.vala"
					_tmp84_ = _file_index;
#line 307 "../src/projects/buildtask.vala"
					_tmp85_ = _file_size;
#line 307 "../src/projects/buildtask.vala"
					if (!(_tmp84_ < _tmp85_)) {
#line 307 "../src/projects/buildtask.vala"
						break;
#line 2866 "buildtask.c"
					}
#line 307 "../src/projects/buildtask.vala"
					_tmp86_ = _file_list;
#line 307 "../src/projects/buildtask.vala"
					_tmp87_ = gee_abstract_list_get ((GeeAbstractList*) _tmp86_, _file_index);
#line 307 "../src/projects/buildtask.vala"
					file = (GFile*) _tmp87_;
#line 308 "../src/projects/buildtask.vala"
					_tmp88_ = self->priv->_file_cache;
#line 308 "../src/projects/buildtask.vala"
					_tmp89_ = file;
#line 308 "../src/projects/buildtask.vala"
					vls_file_cache_update (_tmp88_, _tmp89_, cancellable, &_inner_error0_);
#line 308 "../src/projects/buildtask.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 308 "../src/projects/buildtask.vala"
						g_propagate_error (error, _inner_error0_);
#line 308 "../src/projects/buildtask.vala"
						_g_object_unref0 (file);
#line 308 "../src/projects/buildtask.vala"
						_g_object_unref0 (process);
#line 308 "../src/projects/buildtask.vala"
						return;
#line 2890 "buildtask.c"
					}
#line 307 "../src/projects/buildtask.vala"
					_g_object_unref0 (file);
#line 2894 "buildtask.c"
				}
			}
#line 309 "../src/projects/buildtask.vala"
			_tmp90_ = g_time_zone_new_local ();
#line 309 "../src/projects/buildtask.vala"
			_tmp91_ = _tmp90_;
#line 309 "../src/projects/buildtask.vala"
			_tmp92_ = g_date_time_new_now (_tmp91_);
#line 309 "../src/projects/buildtask.vala"
			_tmp93_ = _tmp92_;
#line 309 "../src/projects/buildtask.vala"
			vls_build_target_set_last_updated ((VlsBuildTarget*) self, _tmp93_);
#line 309 "../src/projects/buildtask.vala"
			_g_date_time_unref0 (_tmp93_);
#line 309 "../src/projects/buildtask.vala"
			_g_time_zone_unref0 (_tmp91_);
#line 2911 "buildtask.c"
		}
	}
#line 250 "../src/projects/buildtask.vala"
	_g_object_unref0 (process);
#line 2916 "buildtask.c"
}

GeeArrayList*
vls_build_task_get_used_files (VlsBuildTask* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 34 "../src/projects/buildtask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/projects/buildtask.vala"
	_tmp0_ = self->priv->_used_files;
#line 34 "../src/projects/buildtask.vala"
	result = _tmp0_;
#line 34 "../src/projects/buildtask.vala"
	return result;
#line 2932 "buildtask.c"
}

static void
vls_build_task_set_used_files (VlsBuildTask* self,
                               GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 34 "../src/projects/buildtask.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/projects/buildtask.vala"
	old_value = vls_build_task_get_used_files (self);
#line 34 "../src/projects/buildtask.vala"
	if (old_value != value) {
#line 2946 "buildtask.c"
		GeeArrayList* _tmp0_;
#line 34 "../src/projects/buildtask.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 34 "../src/projects/buildtask.vala"
		_g_object_unref0 (self->priv->_used_files);
#line 34 "../src/projects/buildtask.vala"
		self->priv->_used_files = _tmp0_;
#line 34 "../src/projects/buildtask.vala"
		g_object_notify_by_pspec ((GObject *) self, vls_build_task_properties[VLS_BUILD_TASK_USED_FILES_PROPERTY]);
#line 2956 "buildtask.c"
	}
}

GeeArrayList*
vls_build_task_get_candidate_inputs (VlsBuildTask* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 41 "../src/projects/buildtask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/projects/buildtask.vala"
	_tmp0_ = self->priv->_candidate_inputs;
#line 41 "../src/projects/buildtask.vala"
	result = _tmp0_;
#line 41 "../src/projects/buildtask.vala"
	return result;
#line 2973 "buildtask.c"
}

static void
vls_build_task_set_candidate_inputs (VlsBuildTask* self,
                                     GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 41 "../src/projects/buildtask.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/projects/buildtask.vala"
	old_value = vls_build_task_get_candidate_inputs (self);
#line 41 "../src/projects/buildtask.vala"
	if (old_value != value) {
#line 2987 "buildtask.c"
		GeeArrayList* _tmp0_;
#line 41 "../src/projects/buildtask.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 41 "../src/projects/buildtask.vala"
		_g_object_unref0 (self->priv->_candidate_inputs);
#line 41 "../src/projects/buildtask.vala"
		self->priv->_candidate_inputs = _tmp0_;
#line 41 "../src/projects/buildtask.vala"
		g_object_notify_by_pspec ((GObject *) self, vls_build_task_properties[VLS_BUILD_TASK_CANDIDATE_INPUTS_PROPERTY]);
#line 2997 "buildtask.c"
	}
}

static void
vls_build_task_class_init (VlsBuildTaskClass * klass,
                           gpointer klass_data)
{
#line 24 "../src/projects/buildtask.vala"
	vls_build_task_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/projects/buildtask.vala"
	g_type_class_adjust_private_offset (klass, &VlsBuildTask_private_offset);
#line 24 "../src/projects/buildtask.vala"
	((VlsBuildTargetClass *) klass)->build_if_stale = (void (*) (VlsBuildTarget*, GCancellable*, GError**)) vls_build_task_real_build_if_stale;
#line 24 "../src/projects/buildtask.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_vls_build_task_get_property;
#line 24 "../src/projects/buildtask.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_vls_build_task_set_property;
#line 24 "../src/projects/buildtask.vala"
	G_OBJECT_CLASS (klass)->finalize = vls_build_task_finalize;
#line 3017 "buildtask.c"
	/**
	     * Because a built task could be any command, we don't know whether the files
	     * that appear in the arg list are inputs or outputs initially.
	     */
#line 24 "../src/projects/buildtask.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), VLS_BUILD_TASK_USED_FILES_PROPERTY, vls_build_task_properties[VLS_BUILD_TASK_USED_FILES_PROPERTY] = g_param_spec_object ("used-files", "used-files", "used-files", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3024 "buildtask.c"
	/**
	     * Candidate inputs are files that _may_ be inputs (and only inputs) to
	     * this task but that we cannot determine yet. They may not exist now, but
	     * they are expected to exist at the time this target is built.
	     */
#line 24 "../src/projects/buildtask.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), VLS_BUILD_TASK_CANDIDATE_INPUTS_PROPERTY, vls_build_task_properties[VLS_BUILD_TASK_CANDIDATE_INPUTS_PROPERTY] = g_param_spec_object ("candidate-inputs", "candidate-inputs", "candidate-inputs", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3032 "buildtask.c"
}

static void
vls_build_task_instance_init (VlsBuildTask * self,
                              gpointer klass)
{
	gchar** _tmp0_;
	gchar* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
#line 24 "../src/projects/buildtask.vala"
	self->priv = vls_build_task_get_instance_private (self);
#line 25 "../src/projects/buildtask.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 25 "../src/projects/buildtask.vala"
	self->priv->arguments = _tmp0_;
#line 25 "../src/projects/buildtask.vala"
	self->priv->arguments_length1 = 0;
#line 25 "../src/projects/buildtask.vala"
	self->priv->_arguments_size_ = self->priv->arguments_length1;
#line 26 "../src/projects/buildtask.vala"
	_tmp1_ = g_strdup ("");
#line 26 "../src/projects/buildtask.vala"
	self->priv->exe_name = _tmp1_;
#line 34 "../src/projects/buildtask.vala"
	_tmp2_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 34 "../src/projects/buildtask.vala"
	if (_tmp2_) {
#line 34 "../src/projects/buildtask.vala"
		g_object_set_data ((GObject *) _tmp2_, "vala-creation-function", "");
#line 3063 "buildtask.c"
	}
#line 34 "../src/projects/buildtask.vala"
	self->priv->_used_files = _tmp2_;
#line 41 "../src/projects/buildtask.vala"
	_tmp3_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 41 "../src/projects/buildtask.vala"
	if (_tmp3_) {
#line 41 "../src/projects/buildtask.vala"
		g_object_set_data ((GObject *) _tmp3_, "vala-creation-function", "");
#line 3073 "buildtask.c"
	}
#line 41 "../src/projects/buildtask.vala"
	self->priv->_candidate_inputs = _tmp3_;
#line 3077 "buildtask.c"
}

static void
vls_build_task_finalize (GObject * obj)
{
	VlsBuildTask * self;
#line 24 "../src/projects/buildtask.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VLS_TYPE_BUILD_TASK, VlsBuildTask);
#line 25 "../src/projects/buildtask.vala"
	self->priv->arguments = (_vala_array_free (self->priv->arguments, self->priv->arguments_length1, (GDestroyNotify) g_free), NULL);
#line 26 "../src/projects/buildtask.vala"
	_g_free0 (self->priv->exe_name);
#line 27 "../src/projects/buildtask.vala"
	_g_free0 (self->priv->build_dir);
#line 28 "../src/projects/buildtask.vala"
	_g_object_unref0 (self->priv->launcher);
#line 34 "../src/projects/buildtask.vala"
	_g_object_unref0 (self->priv->_used_files);
#line 41 "../src/projects/buildtask.vala"
	_g_object_unref0 (self->priv->_candidate_inputs);
#line 43 "../src/projects/buildtask.vala"
	_g_object_unref0 (self->priv->_file_cache);
#line 24 "../src/projects/buildtask.vala"
	G_OBJECT_CLASS (vls_build_task_parent_class)->finalize (obj);
#line 3102 "buildtask.c"
}

/**
 * Represents a build target when it is an arbitrary command.
 */
 G_GNUC_NO_INLINE static GType
vls_build_task_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VlsBuildTaskClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vls_build_task_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VlsBuildTask), 0, (GInstanceInitFunc) vls_build_task_instance_init, NULL };
	GType vls_build_task_type_id;
	vls_build_task_type_id = g_type_register_static (VLS_TYPE_BUILD_TARGET, "VlsBuildTask", &g_define_type_info, 0);
	VlsBuildTask_private_offset = g_type_add_instance_private (vls_build_task_type_id, sizeof (VlsBuildTaskPrivate));
	return vls_build_task_type_id;
}

GType
vls_build_task_get_type (void)
{
	static gsize vls_build_task_type_id__once = 0;
	if (g_once_init_enter (&vls_build_task_type_id__once)) {
		GType vls_build_task_type_id;
		vls_build_task_type_id = vls_build_task_get_type_once ();
		g_once_init_leave (&vls_build_task_type_id__once, vls_build_task_type_id);
	}
	return vls_build_task_type_id__once;
}

static void
_vala_vls_build_task_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	VlsBuildTask * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VLS_TYPE_BUILD_TASK, VlsBuildTask);
#line 24 "../src/projects/buildtask.vala"
	switch (property_id) {
#line 24 "../src/projects/buildtask.vala"
		case VLS_BUILD_TASK_USED_FILES_PROPERTY:
#line 24 "../src/projects/buildtask.vala"
		g_value_set_object (value, vls_build_task_get_used_files (self));
#line 24 "../src/projects/buildtask.vala"
		break;
#line 24 "../src/projects/buildtask.vala"
		case VLS_BUILD_TASK_CANDIDATE_INPUTS_PROPERTY:
#line 24 "../src/projects/buildtask.vala"
		g_value_set_object (value, vls_build_task_get_candidate_inputs (self));
#line 24 "../src/projects/buildtask.vala"
		break;
#line 3152 "buildtask.c"
		default:
#line 24 "../src/projects/buildtask.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/projects/buildtask.vala"
		break;
#line 3158 "buildtask.c"
	}
}

static void
_vala_vls_build_task_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	VlsBuildTask * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VLS_TYPE_BUILD_TASK, VlsBuildTask);
#line 24 "../src/projects/buildtask.vala"
	switch (property_id) {
#line 24 "../src/projects/buildtask.vala"
		case VLS_BUILD_TASK_USED_FILES_PROPERTY:
#line 24 "../src/projects/buildtask.vala"
		vls_build_task_set_used_files (self, g_value_get_object (value));
#line 24 "../src/projects/buildtask.vala"
		break;
#line 24 "../src/projects/buildtask.vala"
		case VLS_BUILD_TASK_CANDIDATE_INPUTS_PROPERTY:
#line 24 "../src/projects/buildtask.vala"
		vls_build_task_set_candidate_inputs (self, g_value_get_object (value));
#line 24 "../src/projects/buildtask.vala"
		break;
#line 3184 "buildtask.c"
		default:
#line 24 "../src/projects/buildtask.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/projects/buildtask.vala"
		break;
#line 3190 "buildtask.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

